EMapMode = {Mode_3D = 1, Mode_2D = 2, Mode_2D_NU = 3}
wGetNUSupported = EMapMode.Mode_2D_NU == 3 and sc_GetSysEntry("map", "north_up", 0)
vgj_spc_cat_name = ""
gjRI_CalckEvent = 0

sc_start_customize = function()
	sc_wBuildCockpitMenu()
	ui.fullCockpitMenuList:sort("menu_index")
	sc_gjMapchangerProvider_check() 	
	sc_gjSPfix_tolerance_change()
	sc_gj_set_position()
	sc_NaviMenuAlphaRestore()
	sc_gj_start()
	obs_timer:START()
	sc_wOnSplitScreenPOI()
	if MODEL.lua.vEasyMapMode() > 2 and not wGetNUSupported then
		MODEL.lua.vEasyMapMode = 1
	end
end

sc_gj_start = function()
--gj start sound
	doDelayed(20, function()
		sc_gjplaysound(MODEL.lua.vgjStartSoundName(), MODEL.lua.vgjStartVolume())
	end
	)   
end
	
sc_set_MAPresolution()

sc_gj_set_position = function()

	if MODEL.lua.vgjLaneTopSet() then
		sprLaneInfoEasy:Y(sc_ToPercent(sc_GetRealValueW(17)))
	else
		sprLaneInfoEasy:Y(sc_ToPercent(sc_GetRealValueW(86)))
	end

--	if MODEL.lua.vgjMiniJunction() then
--		padJunctionView:X(sc_ToPercent(sc_GetRealValueW(66))) 
--		padJunctionView:Y(sc_ToPercent(sc_GetRealValueW(32))) 
--		padJunctionView:W(sc_ToPercent(sc_GetRealValueW(33))) 
--		padJunctionView:H(sc_ToPercent(sc_GetRealValueW(37)))

--		sprJunctionView:X(sc_ToPercent(sc_GetRealValueW(67))) 
--		sprJunctionView:Y(sc_ToPercent(sc_GetRealValueW(33))) 
--		sprJunctionView:W(sc_ToPercent(sc_GetRealValueW(31))) 
--		sprJunctionView:H(sc_ToPercent(sc_GetRealValueW(35)))
--	else
		sprJunctionView:X(0) 
		sprJunctionView:Y(0) 
		sprJunctionView:W(sc_ToPercent(sc_GetRealValueW(100))) 
		sprJunctionView:H(sc_ToPercent(sc_GetRealValueW(100)))
--	end		

end

sc_gj_restrictsound = function(fromstart)  
  if MODEL.lua.vgjShowRestTurn() and MODEL.lua.vgjSoundRestTurn() then
	sc_DADing()
    if MODEL.navigation.turn_restriction_icon.valid() and fromstart then
	  ob_gj_turnrest_chg:START("NO_TRIGGER")
    end
  end
end

sc_gj_turnrest_change_start = function()
	gjTurnRestDelayed = doDelayed(1, function() sc_gj_restrictsound(true) end)
end

sc_gj_turnrest_change_stop = function()
	if gjTurnRestDelayed ~= -1 then
		killDelayed(gjTurnRestDelayed)
		gjTurnRestDelayed = -1
	end
	ob_gj_turnrest_chg:STOP()
end

TmpSpLim = 0
sc_gj_spchangesound = function() 
    if MODEL.warning.driveralert.speed_limit() > 0 then 
		if TmpSpLim < MODEL.warning.driveralert.speed_limit() then
			sc_gjplaysound(MODEL.lua.vgjSPCHONSoundName(), MODEL.lua.vgjSPCHSoundVolume())
		else
			sc_gjplaysound(MODEL.lua.vgjSPCHOFFSoundName(), MODEL.lua.vgjSPCHSoundVolume())
		end
		TmpSpLim = MODEL.warning.driveralert.speed_limit()
	end
end


if sc_GetSysEntry("utility", "calibratefix", 0) then
   START_APPLICATION("utility/esc.exe","")
   sc_CalibrateScreen()
--gj-ak power mgm
  MODEL.power.powermgm_state = MODEL.lua.vgjPowerMgm()
end



sc_NaviMenuAlphaRestore = function()
	if not MODEL.lua.vgj_ALPHA_autoTran() then
		sc_NaviMenuAlphaDown()
		return
	end	
	MODEL.lua.vgjT_ALPHA_turn = 32
	MODEL.lua.vgjT_ALPHA_nextstreet = 32	
	MODEL.lua.vgjT_ALPHA_currstreet = 32
	MODEL.lua.vgjT_ALPHA_infobar = 32
	MODEL.lua.vgjT_ALPHA_speedbtn = 32
	MODEL.lua.vgjT_ALPHA_tripinfo = 32
	MODEL.lua.vgjT_ALPHA_menu = 32
	MODEL.lua.vgjT_ALPHA_player = 32
	MODEL.lua.vgjT_ALPHA_poi = 32
	killDelayed(TimerAlphaRestore)
	TimerAlphaRestore = doDelayed(300, "sc_NaviMenuAlphaDown()")
end

sc_NaviMenuAlphaDown = function()
	if vActiveState() == "st_easynav" and not MODEL.lua.dragMode() then
		MODEL.lua.vgjT_ALPHA_turn = MODEL.lua.vgj_ALPHA_turn()
		MODEL.lua.vgjT_ALPHA_nextstreet = MODEL.lua.vgj_ALPHA_nextstreet()	
		MODEL.lua.vgjT_ALPHA_currstreet = MODEL.lua.vgj_ALPHA_currstreet()
		MODEL.lua.vgjT_ALPHA_infobar = MODEL.lua.vgj_ALPHA_infobar()
		MODEL.lua.vgjT_ALPHA_speedbtn = MODEL.lua.vgj_ALPHA_speedbtn()
		MODEL.lua.vgjT_ALPHA_tripinfo = MODEL.lua.vgj_ALPHA_tripinfo()
		MODEL.lua.vgjT_ALPHA_menu = MODEL.lua.vgj_ALPHA_menu()
		MODEL.lua.vgjT_ALPHA_player = MODEL.lua.vgj_ALPHA_player()
		MODEL.lua.vgjT_ALPHA_poi = MODEL.lua.vgj_ALPHA_poi()
		MODEL.lua.vgjT_ALPHA_SP = MODEL.lua.vgj_ALPHA_SP()
		MODEL.lua.vEasyNavMapMenuOpen = false
	end
end
 

-- speedcam ---------------------------------------------

-- first play speedcam
sc_gjfirstplayspeedcam = function()
	gjm_spcrep:STOP()
	local spc_cat = MODEL.navigation.curr_speedcam.category()
	local spc_speed = MODEL.navigation.curr_speedcam.speed_limit()
	vgj_spc_cat_name = "speedcam_category:" .. spc_cat
		
	MODEL.lua.gjSpSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_first_sound", L"")
    if MODEL.lua.gjSpSoundName() ~= L"" then
		sc_gjspeedcam_playsound(MODEL.lua.gjSpSoundName())
    end	
	
	MODEL.lua.gjSpeedSound = sc_GetSysEntry(vgj_spc_cat_name, "skin_speed_sound_delay", 0)
    if MODEL.lua.gjSpeedSound() > 0 then
		killDelayed(gjDel1)
		gjDel1 = doDelayed(MODEL.lua.gjSpeedSound(), function()
			sc_gjspeedcam_playsound(spc_speed)
		end
		) 	
    end	
	
	MODEL.lua.gjSpRepDist = sc_GetSysEntry(vgj_spc_cat_name, "skin_repeat_distance", 0)
    if MODEL.lua.gjSpRepDist() > 0 then
		gjm_spcrep:START("NO_TRIGGER")
	end
end

-- repeat play speedcam
sc_gjrepeatplayspeedcam = function()
	gjm_spcrep:STOP()
	MODEL.lua.gjSpRSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_repeat_sound", L"")
    if MODEL.lua.gjSpRSoundName() ~= L"" then
		sc_gjspeedcam_playsound(MODEL.lua.gjSpRSoundName())
    end	
end


-- play off speedcam
sc_gj_spcoff = function()
	gjm_spcrep:STOP()	
	MODEL.lua.gjSpFSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_off_sound", L"")
    if MODEL.lua.gjSpFSoundName() ~= L"" then
		sc_gjspeedcam_playsound(MODEL.lua.gjSpFSoundName())
    end		
end    

sc_gjspeedcam_playsound = function(sound)
	if sound == L"" then
		return
	end
	
	local spc_audio_path = sc_GetSysEntry("warning", "skin_speedcam_audio_path", L"")
    if spc_audio_path ~= L"" then
		sound = spc_audio_path .. L"/" .. sound
	end
	
	MODEL.sound.playchanneltest("alarmeffect", sound)
end 

-- speed tolerance ---------------------------------------------

sc_gjSPfix_tolerance_change = function()
	if MODEL.warning.speedwarn_alt_toltype() then
		MODEL.warning.speedwarn_alt_tolerance = MODEL.lua.vgjspeed_in_city()
		MODEL.warning.speedwarn_tolerance = MODEL.lua.vgjspeed_out_of_city()
	else
		MODEL.warning.speedwarn_alt_tolerance = MODEL.lua.vgjspeed_in_city()+100
		MODEL.warning.speedwarn_tolerance = MODEL.lua.vgjspeed_out_of_city()+100
	end
	MODEL.warning.speedwarn_toltype = MODEL.warning.speedwarn_alt_toltype()
end


st_SpeedWarningSettings.exit = function()
	sc_gjSPfix_tolerance_change()
end


sc_GetAdvancedSpeedLimitPhase_orig = sc_GetAdvancedSpeedLimitPhase
sc_GetAdvancedSpeedLimitPhase = function(speed, speed_limit)
	if MODEL.navigation.car.is_incity() then
		if MODEL.warning.speedwarn_alt_toltype() then 
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit + MODEL.warning.speedwarn_alt_tolerance() then
				return 1
			else
				return 2
			end	
		else
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit * MODEL.warning.speedwarn_alt_tolerance() / 100 then
				return 1
			else
				return 2
			end	
		end
	else	
		if MODEL.warning.speedwarn_alt_toltype() then 
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit + MODEL.warning.speedwarn_tolerance() then
				return 1
			else
				return 2
			end	
		else
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit * MODEL.warning.speedwarn_tolerance() / 100 then
				return 1
			else
				return 2
			end	
		end
  end
end

-- lane sound --------------------------------------------------
 
sc_LaneInfoVisibleOnchange_orig = sc_LaneInfoVisibleOnchange
sc_LaneInfoVisibleOnchange = function()
  if MODEL.lua.laneInfoVisible() then
    sprLaneInfoEasy:BLENDALPHA(0, MODEL.lua.vgj_ALPHA_Lane(), 20)
	sc_gjplaysound(MODEL.lua.vgjLaneSoundName(), MODEL.lua.vgjLaneSoundVolume()) 
  else
    sprLaneInfoEasy:BLENDALPHA(MODEL.lua.vgj_ALPHA_Lane(), 0, 20)
  end
end


sc_SignPostLayerShow_orig = sc_SignPostLayerShow
sc_SignPostLayerShow = function()
  if st_EasyNav.active and not MODEL.lua.SignpostIsValid() and MODEL.lua.SignpostOn() then
--    sc_AngleSignPost()
	sc_Angle_SP()
    MODEL.lua.SignpostIsValid = true
    ui_NavigateMapSingpost.Y = -vLaneInfoSignpostHeight()
    ui_NavigateMapSingpost:YBLEND(0, 15)
	sc_gjplaysound(MODEL.lua.vgjLaneSoundName(), MODEL.lua.vgjLaneSoundVolume()) 
  end
  obs_want_junctionview:TRIGGER()
end


-- short menu --------------------------------------------------

sc_OpenMapMenu_orig = sc_OpenMapMenu
sc_OpenMapMenu = function()
	sc_NaviMenuAlphaRestore()
	MODEL.lua.vEasyNavMapMenuOpen = not MODEL.lua.vEasyNavMapMenuOpen()
    killDelayed(gjopenmenuevent)
    gjopenmenuevent = doDelayed(300, function()
		MODEL.lua.vEasyNavMapMenuOpen = false
	end
	)
end


sc_wBuildCockpitMenu = function()
	local menuItems = {}
	for i = 0, 8 do
		local itemIdx = sc_gjFindItemInCockpitList(PERSISTENT.gj_savedCockpitMenu[i]())
		MODEL.ui.fullCockpitMenuList[itemIdx].is_in_menu = true
		MODEL.ui.fullCockpitMenuList[itemIdx].menu_index = i
	end
end

createState("st_gjCustomizeCockpitMenu")
st_gjCustomizeCockpitMenu:useLayers(primary, uieffect, ui_gjCustomizeCockpitMenu)

createState("st_gjCockpitMenuReplaceList")
st_gjCockpitMenuReplaceList:useLayers(backgroundLayers, ui_gjCockpitMenuReplaceList)
st_gjCockpitMenuReplaceList.init = function()
	txtTitle:SET(m_i18n("Select a Shortcut"))
	ui.fullCockpitMenuList:sort("uniq_id")
end

st_gjCockpitMenuReplaceList.exit = function()
	ui.fullCockpitMenuList:sort("menu_index")
end

sc_gjReplaceSelectedCockpitMenuItem = function(itemId)
	local oldId = PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct]()
	local oldItemIdx = sc_gjFindItemInCockpitList(oldId)
	local newItemIdx = sc_gjFindItemInCockpitList(itemId)
	if MODEL.ui.fullCockpitMenuList[newItemIdx].is_in_menu() then
		if itemId == oldId then
			return 
		end
		local newItemIdxForSwap = MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index()
		MODEL.ui.fullCockpitMenuList[oldItemIdx].menu_index = MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index()
		MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct] = itemId
		PERSISTENT.gj_savedCockpitMenu[newItemIdxForSwap] = oldId
	else
		MODEL.ui.fullCockpitMenuList[oldItemIdx].is_in_menu = false
		MODEL.ui.fullCockpitMenuList[oldItemIdx].menu_index = 100
		MODEL.ui.fullCockpitMenuList[oldItemIdx].cockpitvisible = true
		MODEL.ui.fullCockpitMenuList[newItemIdx].is_in_menu = true
		MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct] = itemId
	end
end

sc_gjFindItemInCockpitList = function(itemId)
	for i = 0, MODEL.ui.fullCockpitMenuList.size() - 1 do
		if MODEL.ui.fullCockpitMenuList[i].id() == itemId then
			return i
		end
	end
	return -1
end

sc_gjOpenCockpitMenuItem = function(index)
	if vActiveState() == "st_easynav" then
		local scriptName = MODEL.ui.fullCockpitMenuList.quick_list[index].onrelease()
		_G[scriptName]()
	else
		vMapMenuButtonAct = index
		sc_NextStateAnim(st_gjCockpitMenuReplaceList, "horz_scroll", 1, "")
	end
end
 
sc_gjOpenLongCockpitMenuItem = function(index)
	local scriptName = MODEL.ui.fullCockpitMenuList.quick_list[index].onlongclick()
	if scriptName == "" then
		sc_gjShowHelpText(MODEL.ui.fullCockpitMenuList.quick_list[index].text())
	else
		_G[scriptName]()
	end
end 

-- other ----------------------------------------------------------------

sc_gjShowHelpText = function(text)
	txtHelpText:TEXT(text)
	if gjShowHelpTextTimer ~= -1 then
		killDelayed(gjShowHelpTextTimer )
		gjShowHelpTextTimer = -1
	end
	ui_gjHelpText:SHOW()
	gjShowHelpTextTimer = doDelayed(100, function()
		ui_gjHelpText:HIDE()
	end
	)
end 

sc_MapSettings_BottomMenu = function()
	sc_NextStateAnim(st_gjCustomizeCockpitMenu, "fade", 1, "")
end
 
sc_Show_Calculator = function()
	sc_NextStateAnim(st_Calculator, "fade", 1, "")
end

sc_Quick_mute = function()
	MODEL.sound.os_muted = not MODEL.sound.os_muted()
end 
 
sc_gjStopTrackLog = function()
	sc_StopTrackLog()
end

sc_gjStartTrackLog = function()
	sc_StartTrackLog()
end 
 
sc_Quick_mute_onlongclick = function()
	sc_NextStateAnim(st_VolumeSetting, "fade", 1, "")
end

sc_Quick_record_onlongclick = function()
	sc_NextStateAnim(st_tracklog, "fade", 1, "")
end
 

sc_Quick_FindAddress_onlongclick = function()
	sc_NextStateAnim(st_FindAddress, "horz_scroll", 1, "")
end

sc_gjallsettings_OnRelease = function()
	sc_NextStateAnim(st_EasySettingsMenu, "horz_scroll", 1, "")
end

sc_gjdelroute_OnRelease = function()
	if MODEL.route.list.navigated.waypoints.list.size() > 2 then
		sc_DeleteNextWaypoint()
	else
		sc_map_local_menu_deleteroute()
		vDestinationReachedPopoUpID:SET(-1)
	end
	sc_back_to_cockpit()
	doDelayed(10, function()
		sc_back_to_cockpit()
	end
	)
	
end
 
sc_gj_DoToll = function()
  MODEL.route.allow_toll = not MODEL.route.allow_toll()
  MODEL.route.saverouteparams()
  MODEL.route.recalculate()
  doDelayed(30, function()
	MODEL.lua.vEasyNavMapMenuOpen = false
  end
  )
end

sc_gj_2d3d = function()
  if MODEL.lua.vEasyMapMode() < (wGetNUSupported and 3 or 2) then
	MODEL.lua.vEasyMapMode = MODEL.lua.vEasyMapMode() + 1
  else
	MODEL.lua.vEasyMapMode = 1
  end
  if MODEL.navigation.is_in_simulation() then
	sc_ChangeFlyOverModeState()
  else
	sc_set_Nav2D3D()
  end
end
 
-- position

createState("st_gjUserPosition")
st_gjUserPosition:useLayers(backgroundLayers, ui_gjUserPosition)
st_gjUserPosition.init = function()
	txtTitle:SET(m_i18n("Select position"))
	MODEL.lua.gjShowPosInfo = false
end

sc_gj_open_ListPosition = function()
	sc_NextStateAnim(st_gjUserPosition, "horz_scroll", 1, "")
end

sc_gjUserPositionAdd_OnRelease_OK = function(PosType)
    local gcoor = MODEL.navigation.car.position()
	local gcity = MODEL.navigation.car.address.city()
	local gstreet = MODEL.navigation.car.address.street()
	local SpeedLimit = MODEL.warning.driveralert.speed_limit()
	local CurrentSpeed = MODEL.navigation.car.current_speed()
	local glat = Format_GeoCoord(gcoor,EGeoCoordDisplayMode.Latitude_Only)
	local glong = Format_GeoCoord(gcoor,EGeoCoordDisplayMode.Longitude_Only)
	
	if gcity == L"" then
		gcity = gstreet
	else
	   gcity = gcity .. L", " .. gstreet
	end
	
	ui.gjUserPositionList:add({plat=glat, plong=glong, paddr=gcity, pdate=sc_DateToWStr(MODEL.gps.current_date()), ptime=MODEL.other.format_time_dayperiod(MODEL.gps.current_time(), 0, 0), pspeedlim=SpeedLimit,  pspeed=CurrentSpeed,  ptype=PosType})
	MODEL.ui.gjUserPositionList.save()
	sc_gjShowHelpText(m_i18n("Position saved!"))
end


sc_gjUserPositionInfo_OnRelease = function()
	gj_pdatText:SET(m_i18n(MODEL["*"].pdate() .. L" " .. MODEL["*"].ptime()))
	gj_pcordText:SET(m_i18n(MODEL["*"].plat() .. L" " .. MODEL["*"].plong()))
	gj_paddrText:SET(m_i18n(MODEL["*"].paddr()))
	
	local text = m_i18n(MODEL["*"].pspeedlim())
	if text == L"0" then
		text = "!"
	end
	gj_plimspeedText:SET(text)	
	gj_pcrspeedText:SET(m_i18n(MODEL["*"].pspeed()))
	
	MODEL.lua.gjTypePosInfo = m_i18n(MODEL["*"].ptype())
	
	MODEL.lua.gjShowPosInfo = true
end


sc_gj_UserPositionDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this position from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].pdate() .. L" " .. MODEL["*"].ptime())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserPositionDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end

sc_gjUserPositionDel_OnRelease_OK = function()
	MODEL.ui.gjUserPositionList.remove(MODEL.ui.gjUserPositionList.list.index())
	MODEL.ui.gjUserPositionList.save()
end


sc_gj_UserPositionAll_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete all positions from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserPositionAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end


sc_gjUserPositionAll_OnRelease_OK = function()
	MODEL.ui.gjUserPositionList.clear()
	MODEL.ui.gjUserPositionList.save()
end
 
sc_gjUserPositionFindOnRelease = function()
	local index = MODEL.ui.gjUserPositionList.index()
	local plat = MODEL.ui.gjUserPositionList[index].plat()
	local plong = MODEL.ui.gjUserPositionList[index].plong()
	if MODEL.lua.Utm() then
		local zone_number, zone_letter = parse_zone(MODEL.lua.gcoor_zonetext())
		MODEL.lua.gcoor_to_find = GCOOR.new({zone_number = zone_number, zone_letter = zone_letter, x = tonumber(plat), y = tonumber(plong)})
	else
		local temp = var.new()
		temp:SET(plat)
		MODEL.regional.unlocalize_gcoor(temp)
		local geocoord_input_lat = parse_gcoor(tostring(temp()))
		ASSERT(geocoord_input_lat ~= nil)
		temp:SET(plong)
		MODEL.regional.unlocalize_gcoor(temp)
		local geocoord_input_lon = parse_gcoor(tostring(temp()))
		ASSERT(geocoord_input_lon ~= nil)
		MODEL.lua.gcoor_to_find = GCOOR.new({lat = geocoord_input_lat, lon = geocoord_input_lon})
	end
	sc_Input_GeoCoord_Ok()
end


-- mapchanger ----------------------------------------------------------------

gjMapProvider = 0 
 
createState("st_gjMapChanger")
st_gjMapChanger:useLayers(backgroundLayers, ui_gjMapChanger)
st_gjMapChanger.init = function()
	txtTitle:SET(m_i18n("MapChanger"))
end

sc_gjMapChanger_OnRelease = function()
	sc_NextStateAnim(st_gjMapChanger, "fade", 1, "")
end

sc_gjMapChanger_go = function(provider)
	if MODEL.lua.vgjMCCurrentMap() ~= provider then
		gjMapProvider = provider
		MODEL.screen.msgbox.new.setup(2)
		MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to change Map provider?"))
		MODEL.screen.msgbox.new.setup_button(1, "sc_gjMapChanger_goDone", m_i18n("Change provider"), L"", "ico_done_mid.bmp#3")
		MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
		MODEL.screen.msgbox.create_new()
	end	
end

sc_gjMapChanger_goDone = function()
	MODEL.lua.vgjMCCurrentMap = gjMapProvider
	local param = "," .. tostring(gjMapProvider)
	NEXTSTATE(RestartState)
	doDelayed(15, function()
		START_APPLICATION("utility/mapchanger.exe",param)
		doDelayed(1,EXIT)
	end
	)
end
 
sc_gjMapchangerProvider_check = function()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L"%content%/map"
	oasisFiles.filter = L"fcategory:1"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_MapsScan_Finished:START("NO_TRIGGER")
end
 
sc_Mapchanger_check_done = function()
	obs_Files_MapsScan_Finished:STOP()
	local name = L""
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		name = MODEL.oasis.files.list[i].fname()
		if name == L"!map_ta.txt" or name == L"!MAP_TA.TXT" or name == L"!map_tt.txt" or name == L"!MAP_TT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 1
			break
		end
		if name == L"!map_nt.txt" or name == L"!MAP_NT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 2
			break
		end
		if name == L"!map_ot.txt" or name == L"!MAP_OT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 3
			break
		end
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
end 

-- TMC manual tuning
sc_TMCTuning_Up = function()
  MODEL.tmc.tuner_step_up()
end

sc_TMCTuning_Down = function()
  MODEL.tmc.tuner_step_down()
end

sc_TMCTuning_SearchUp = function()
  MODEL.tmc.tuner_search_up()
end

sc_TMCTuning_SearchDown = function()
  MODEL.tmc.tuner_search_down()
end

sc_TMCTuning_Auto = function()
  if MODEL.tmc.auto_tuning() == true then
      MODEL.tmc.auto_tuning = false
  else
      MODEL.tmc.auto_tuning = true
  end
--  sc_close_local_menu()
end

--gj panic
sc_gjm_enable_panic = function()
  if MODEL.warning.speedcam_warning() then
	MODEL.screen.msgbox.new.setup(3)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("SpeedCam Database"))
    MODEL.screen.msgbox.new.setup_button(1, "sc_gjm_move_panic", m_i18n("Move"), "", "ico_minimize.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_gjm_delete_panic", m_i18n("Delete"), "", "ico_cancel_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(3, "sc_back_to_cockpit", m_i18n("Cancel"), "", "")
  else
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("SpeedCam Database"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjm_restore_panic", m_i18n("Restore"), L"", "ico_done_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_back_to_cockpit", m_i18n("Cancel"), L"", "")
  end
	MODEL.screen.msgbox.create_new()
end

sc_gjm_move_panic = function()
	sc_SpeedcamWarningDisabled()
	NEXTSTATE(RestartState)
	doDelayed(50, function()
	START_APPLICATION("./utility/utility.exe",",1,")
		doDelayed(1,EXIT)
	end
	)
end

sc_gjm_delete_panic = function()
	sc_SpeedcamWarningDisabled()
	NEXTSTATE(RestartState)
	doDelayed(50, function()
	START_APPLICATION("./utility/utility.exe",",2,")
		doDelayed(1,EXIT)
	end
	)
end

sc_gjm_restore_panic = function()
	sc_SpeedcamWarningEnabled()
	NEXTSTATE(RestartState)
	doDelayed(50, function()
	START_APPLICATION("./utility/utility.exe",",3,")
		doDelayed(1,EXIT)
	end
	)
end

-- menu settings

createState("st_gj_Settings")
st_gj_Settings:useLayers(backgroundLayers, ui_gj_Settings)
st_gj_Settings.init = function()
	txtTitle:SET(m_i18n("GJ Settings"))
end

sc_btnASM_gj_OnRelease = function()
  sc_NextStateAnim(st_gj_Settings, "horz_scroll", 1, "")
end


-- transparecy settings

createState("st_gj_transprency_Settings")
st_gj_transprency_Settings:useLayers(backgroundLayers, ui_gj_transprency_Settings)
st_gj_transprency_Settings.init = function()
  txtTitle:SET(m_i18n("Transparency Settings"))
end

sc_gj_transprency_OnRelease = function()
  sc_NextStateAnim(st_gj_transprency_Settings, "horz_scroll", 1, "")
end

-- cockpit settings
   
createState("st_gj_cockpit_settings")
st_gj_cockpit_settings:useLayers(backgroundLayers, ui_gj_cockpit_settings)
st_gj_cockpit_settings.init = function()
  txtTitle:SET(m_i18n("Cockpit Settings"))
end

sc_gj_cockpit_OnRelease = function()
  sc_NextStateAnim(st_gj_cockpit_settings, "horz_scroll", 1, "")
end

-- more settings
   
createState("st_gj_more_settings")
st_gj_more_settings:useLayers(backgroundLayers, ui_gj_more_settings)
st_gj_more_settings.init = function()
  txtTitle:SET(m_i18n("More Settings"))
end

sc_gj_more_OnRelease = function()
  sc_NextStateAnim(st_gj_more_settings, "horz_scroll", 1, "")
end
 
-- lane settings
   
createState("st_gj_lane_settings")
st_gj_lane_settings:useLayers(backgroundLayers, ui_gj_lane_settings)
st_gj_lane_settings.init = function()
  txtTitle:SET(m_i18n("Lane Settings"))
end

sc_gj_lane_OnRelease = function()
  sc_NextStateAnim(st_gj_lane_settings, "horz_scroll", 1, "")
end


-- warning settings
   
createState("st_gj_warning_settings")
st_gj_warning_settings:useLayers(backgroundLayers, ui_gj_warning_settings)
st_gj_warning_settings.init = function()
  txtTitle:SET(m_i18n("Warning Settings"))
end

sc_gj_warning_OnRelease = function()
  sc_NextStateAnim(st_gj_warning_settings, "horz_scroll", 1, "")
end

-- e_maplayer.lua ----------------------------------------- 

sc_Map_States_Init_orig = sc_Map_States_Init 
sc_Map_States_Init = function()
  for state,initScript in pairs(MapStateInitScripts) do
    MODEL.map.create_state(state)
    initScript(MODEL.map.states[state])
  end
  MODEL.map.create_state("2dnorthup")
  sc_Set_Navmap_2D_NorthUp(MODEL.map.states["2dnorthup"])
  sc_gjLabelsReinit2D()
  sc_gjLabelsReinit3D()
end
 
sc_gjLabelsReinit2D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.setglobal = true
	mapLayer.setglobal_filter = "2dheadup, simulate_2d, 2dnorthup, simulate_2d_nu"
	mapLayer.show_labels_2d = MODEL.lua.vgjLabels_2d()
	mapLayer.setglobal = false
end
 
sc_gjLabelsReinit3D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.setglobal = true
	mapLayer.setglobal_filter = "navmap3d, simulate"
	mapLayer.show_labels_3d = MODEL.lua.vgjLabels_3d()
	mapLayer.navi_mode_3d_labels = MODEL.lua.vgjLabels_navi3d()
	mapLayer.setglobal = false
end 

sc_Set_Navmap_Simulate_2d_NU = function(mapState)
  sc_Set_Common_2DMap(mapState)
  mapState.zoom_lock = false
  mapState.rotate_lock = true
  mapState.center_lock = true
  mapState.center_follow = true
  mapState.zoom_follow = true
  mapState.rotate_follow = true
  mapState.car_posx = 50
  mapState.car_posy = 50
  mapState.center_posx = 50
  mapState.center_posy = 50
  mapState.show_historical_speed = false
  mapState.show_cursor = false
  mapState.auto_set_cursor = false
  mapState.breadcrumbs = false
end

sc_Set_Navmap_2D_NorthUp = function(mapState)
  sc_Set_Common_2DMap(mapState)
  mapState.rotate = 0
  mapState.zoom_lock = false
  mapState.rotate_lock = true
  mapState.center_lock = false
  mapState.center_follow = true
  mapState.zoom_follow = true
  mapState.rotate_follow = true
  mapState.car_posx = 50
  mapState.car_posy = 50
  mapState.center_posx = 50
  mapState.center_posy = 50
  mapState.show_historical_speed = false
  mapState.show_cursor = false
  mapState.auto_set_cursor = true
  MODEL.map.primary.camera_settings.roundabout.centery = 50
end

-- start.lua ----------------------------------------------

sc_reset_primary_orig = sc_reset_primary
sc_reset_primary = function(ResetMapClick)
  primary.X = 0
  primary.Y = 0
  primary.Z = 0
  primary.W = mapResW
  primary.H = mapResH
  primary:SCALE(float.new("1.0"))
  if ResetMapClick then
    primary:ONMAPCLICK()
  end
  MODEL.map.primary.show_labels_3d = MODEL.lua.vgjLabels_3d()
  MODEL.map.primary.show_labels_2d = MODEL.lua.vgjLabels_2d()
end

-- speedcam

sc_gjEditSpeedcam = function()
  gEditSpeedcamFromInfo = false
  sc_CopySpeedCamUserList()
  MODEL.lua.managespeedcam = true
  if #MODEL.map.primary.clicked_speedcam_list == 1 then
    sc_UpdateSpeedcamModels(MODEL.map.primary.clicked_speedcam_list[0])
    sc_NextStateAnim(st_EditSpeedcam, "fade", 1, "")
  else
    sc_NextStateAnim(st_SelectSpeedcam, "fade", 1, "")
  end
end

sc_gjAddSpeedcam = function()
  MODEL.lua.managespeedcam = false
  sc_UpdateSpeedcamModels()
  sc_NextStateAnim(st_EditSpeedcam, "fade", 1, "")
end

-- programs -------------------------------------------------------------
gjSelectProgramMode = false

sc_gj_ExternalPrograms_OnRelease = function()
	gjSelectProgramMode = false
	sc_NextStateAnim(st_gjUserPrograms, "fade", 1, "")
end

createState("st_gjUserPrograms")
st_gjUserPrograms:useLayers(backgroundLayers, ui_gjUserPrograms)
st_gjUserPrograms.init = function()
	txtTitle:SET(m_i18n("Select program"))
end
 
sc_gj_UserProgramsOnRelease = function()
	local current = MODEL.ui.gjUserProgramList[MODEL["*"]._index()]
	if gjSelectProgramMode then
		MODEL.lua.gjMenuLCProgram = MODEL["*"]._index()
		sc_back()
	elseif current.exit() then
		NEXTSTATE(RestartState)
		doDelayed(15, function()
			START_APPLICATION(current.path(),current.parameter())
			doDelayed(1,EXIT)
		end
		)
	else
		START_APPLICATION(current.path(),current.parameter())
	end
end
 
sc_gj_UserProgramsEdit_OnRelease = function()
	local current = MODEL.ui.gjUserProgramList[MODEL["*"]._index()]
	sc_gjUserProgramsEdit_OnRelease = MODEL["*"]._index()
	MODEL.lua.gjProgramName = current.name()
	MODEL.lua.gjSettingProgramParameter = current.parameter()
	MODEL.lua.gjSettingProgramExOn = current.exit()
	sc_NextStateAnim(st_gjUserProgramsEdit, "horz_scroll", 1, "")
end
 
createState("st_gjUserProgramsEdit")
st_gjUserProgramsEdit:useLayers(backgroundLayers, ui_gjUserProgramsEdit)
st_gjUserProgramsEdit.init = function()
	txtTitle:SET(m_i18n("Edit program entry"))
end
 
st_gjUserProgramsEdit.exit = function()
	local current = MODEL.ui.gjUserProgramList[sc_gjUserProgramsEdit_OnRelease]
	current.name = MODEL.lua.gjProgramName()
	current.parameter = MODEL.lua.gjSettingProgramParameter()
	current.exit = MODEL.lua.gjSettingProgramExOn()
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_EditProgramName = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.lua.gjProgramName())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter program name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_gj_EditProgramNameDone)
	inputFieldRequired = false
	txtTitle:SET(m_i18n("Set program name"))
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_EditProgramParameter = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.lua.gjSettingProgramParameter())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter program parameter>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_gj_EditProgramParameterDone)
	inputFieldRequired = false
	txtTitle:SET(m_i18n("Set program parameter"))
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_gj_EditProgramNameDone = function()
	MODEL.lua.gjProgramName = ui.inpSI_Text.VALUE()
	sc_back()
end

sc_gj_EditProgramParameterDone = function()
	MODEL.lua.gjSettingProgramParameter = ui.inpSI_Text.VALUE()
	sc_back()
end
 
sc_gj_UserProgramsDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this program from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_UserProgramsDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_UserProgramsDel_OnRelease_OK = function()
	MODEL.ui.gjUserProgramList.remove(MODEL.ui.gjUserProgramList.list.index())
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_UserProgramsAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all programs from list?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_UserProgramsAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_UserProgramsAll_OnRelease_OK = function()
	MODEL.ui.gjUserProgramList.clear()
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_RescanwUserPrograms_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The previous list will be removed. Are you sure you want to rescan programs?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_RescanwUserPrograms_OnReleaseOK", m_i18n("Rescan programs"), L"", "ico_Done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_RescanwUserPrograms_OnReleaseOK = function()
	ui_gjProgramScanning:SHOW()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L""
	oasisFiles.filter = L"fcategory:2"
	oasisFiles.filter_type = L"PROGRAM"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_UserProgramScan_Finished:START("NO_TRIGGER")
end
 
sc_gj_RescanwUserPrograms_done = function()
	obs_Files_UserProgramScan_Finished:STOP()
	ui_gjProgramScanning:HIDE()
	MODEL.ui.gjUserProgramList.clear()
	local filename = L""
	local fpath = L""
	local length = 0
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		filename = MODEL.oasis.files.list[i].fname()
		fpath = MODEL.oasis.files.list[i].frootpath()
		length = wstring.len(fpath)
		fpath = wstring.sub(fpath, 7, length)
		ui.gjUserProgramList:add({name=filename, path=fpath, parameter=L"", exit=0})
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_RescanwUserPrograms_stop = function()
	obs_Files_UserProgramScan_Finished:STOP()
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	ui_gjProgramScanning:HIDE()
end

--gj autoshutdown --------------------------------------------------
vgAutoAction = nil

createState("st_gj_arrive_settings")
st_gj_arrive_settings:useLayers(backgroundLayers, ui_gj_arrive_settings)
st_gj_arrive_settings.init = function()
  txtTitle:SET(m_i18n("Arrive Settings"))
end

sc_gj_arrive_OnRelease = function()
  sc_NextStateAnim(st_gj_arrive_settings, "horz_scroll", 1, "")
end
 
 
sc_route_finished_Speedcheck_orig = sc_route_finished_Speedcheck
sc_route_finished_Speedcheck = function()
  if MODEL.navigation.car.current_speed() < MODEL.lua.vgjAAD_Speed() and not MODEL.route.list.navigated.calculating() then
    gIdleTime_SpeedCheckTime = gIdleTime_SpeedCheckTime + 1
  else
    gIdleTime_SpeedCheckTime = 0
  end
  if gIdleTime_SpeedCheckTime > 5 then
    sc_route_finished_UIObserver()
    obs_destination_speedcheck:STOP()
  end
end


sc_route_finished_UIObserver_orig = sc_route_finished_UIObserver
sc_route_finished_UIObserver = function()

  if MODEL.lua.vgjAAD_SoundName() ~= L"" then
	sc_gjplaysound(MODEL.lua.vgjAAD_SoundName(), MODEL.lua.vgjAAD_SoundVolume())
  end	 

--gj autoshutdown
  if MODEL.lua.vgjAAD_Mode() == 0 then
  
	-- standard mode --
	if vDestinationReachedPopoUpID() == -1 then
		ui.vDestinationReachedPopoUpID = sc_AddMapPopup(2, m_i18n("Have you arrived at your destination?"), "ico_flag_dest_mid.bmp#3", 1, "sc_GotoDestinationMenu", "", false, nil, 0)
	end

  elseif MODEL.lua.vgjAAD_Mode() == 1 then
	-- gj mode --

	--gj auto delete route
    if MODEL.lua.vgjAAD_RoutDel() then
		sc_DeleteRoute()
	end

	--gj auto save
    if MODEL.lua.vgjAAD_save() then
		sc_SaveTripLogAtDestination()
	end

	--gj auto exit
	if MODEL.lua.vgjAAD_ShdExit() > 0 then
		doDelayed(30, function()
			vgAutoAction = true
			sc_NextStateAnim(st_DestinationMenu, "horz_scroll", 1, "")
		end
		)		
	end

  end

end


st_DestinationMenu.init_orig = st_DestinationMenu.init
st_DestinationMenu.init = function()
  MODEL.screen.msgbox.pause()
  if MODEL.lua.DestinationMenuShown() then
    txtTitle.TEXT = m_i18n("External power removed.")
  else
    txtTitle.TEXT = m_i18n("Destination Menu")
	if gNeedDestinationTimer then
		gDestinationBackIdleTimer = 0
		obs_DestinationBackTimer:START("NO_TRIGGER")
		MODEL.ui._reset_idle_timer()
	end
  end
  if not gLocalMenuIsClosed then
    sc_close_local_menu(true)
  end
  sc_init_local_menu("ui.lm_destinationmenu")
end


st_DestinationMenu.enter_orig = st_DestinationMenu.enter
st_DestinationMenu.enter = function()
  if MODEL.lua.DestinationMenuShown() then
    local shutdownTime = sc_GetSysEntry("interface", "shutdown_time", 10)
    MODEL.power.set_shutdown_timer(shutdownTime)
  else
    ui.vTripLogSavedAtDestination = false
	gNeedDestinationTimer = true
	MODEL.lua.vgjAADMenuTimer = MODEL.lua.vgjAADMenuTimer()
  end	
  ui.vTripLogSavedAtDestination = false
end


sc_CheckDestinationBackIdleTimer = function()
	if gDestinationBackIdleTimer > MODEL.ui._idle_time() then
		obs_DestinationBackTimer:STOP()
		gNeedDestinationTimer = false
	elseif MODEL.ui._idle_time() >= MODEL.lua.vgjAADMenuTimer() then
		sc_CheckDestinationBackIdleTimerDone()
	else
		gDestinationBackIdleTimer = MODEL.ui._idle_time()
	end
end
 
sc_CheckDestinationBackIdleTimerDone = function()
	obs_DestinationBackTimer:STOP()	
    if not vgAutoAction then
		PLAYSOUND( "!button" )
		sc_PrevStateAnim()
	else
		if MODEL.lua.vgjAAD_ShdExit() == 0 then
			MODEL.power.cancel_shutdown()
			sc_PrevStateAnim()
		elseif MODEL.lua.vgjAAD_ShdExit() == 1 then
			sc_DoExit()
		elseif MODEL.lua.vgjAAD_ShdExit() == 2 then
			sc_PrevStateAnim()
			MODEL.power.shutdown()
		end
	end	
end

sc_GetDestinationBackText = function()
  if MODEL.ui._idle_time() == 0 or not gNeedDestinationTimer then
    return m_i18n("Back")
  end
  return translated_format(m_i18n("Back (%s)"), towstring(MODEL.lua.vgjAADMenuTimer() - MODEL.ui._idle_time()))
end 

--gj backlight --------------------------------------------------
createState("st_gj_bcklg_settings")
st_gj_bcklg_settings:useLayers(backgroundLayers, ui_gj_bcklg_settings)
st_gj_bcklg_settings.init = function()
  txtTitle:SET(m_i18n("Backlight Settings"))
end

sc_gj_bcklg_OnRelease = function()
  sc_NextStateAnim(st_gj_bcklg_settings, "horz_scroll", 1, "")
end

--gj restart --------------------------------------------------
sc_gjRestart_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The program will restart."))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjRestart_OnReleaseDone", m_i18n("Restart"), "", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gjRestart_OnReleaseDone = function()
	SAVESETTINGS()
	NEXTSTATE(RestartState)
	doDelayed(25, APP_RESTART)
end 

--gj skin day night --------------------------------------------------
sc_change_day_night = function()
  MODEL.lua.vgjDayNightTrigger = false
  MODEL.lua.vgjDayNightTrigger = true
end

sc_gjTunnelOn = function()
	sc_TunnelOn()
	sc_change_day_night()
end

sc_gjTunnelOff = function()
	sc_TunnelOff()
	sc_change_day_night()
end

sc_SetTheme_orig = sc_SetTheme
sc_SetTheme = function()
  LOGPRINT("Change Colour")
  local themeList = MODEL.screen.theme.list
  MODEL.screen.theme.change_theme(themeList[themeList.index()].filename(), isItNightTheme)
  sc_change_day_night()
end


--gj tripcomp --------------------------------------------------
sc_wGetTripComputerName = function(i)
	return (i==0 and m_i18n("TRACK_TIME~Current Route") or (i==1 and m_i18n("TRACK_TIME~Statistics") or translated_format(m_i18n("TRACK_TIME~User Trip %s"), towstring(i-1))))
end
 
sc_wTripComputer_OnRelease = function()
	sc_NextStateAnim(st_wTripComputer, "fade", 1, "")
end
 
createState("st_wTripComputer")
st_wTripComputer:useLayers(ui_wTripComputer, backgroundLayers)
st_wTripComputer.init = function()
	txtTitle:SET(m_i18n("Trip Computer"))
end
 
sc_wTripComputerPause = function()
	MODEL.other.trips[index].pause()
end
 
sc_wTripComputerReset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("This will reset this trip."))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wTripComputerResetOK", m_i18n("Trip~Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wTripComputerResetOK = function()
	MODEL.other.trips[MODEL.other.trips.index()].reset()
end 

sc_gj_reset_trc = function()
	MODEL.other.trips[0].reset()
end

sc_gj_tripcompreset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset trip computer?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_reset_trc", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end 


st_Start.init_orig = st_Start.init
st_Start.init = function()
  sc_LoadTrafficEventTypeSettings()
  MODEL.traffic.events.sort_by(MODEL.lua.trafficEventSorting())
  sc_CreateKeyboardPanelsLocalMenu()
  sc_SetEnabledKeyboardPanels()
  sc_GetSysEntry_Init()
  if MODEL.lua.Currency() == L"" then
    MODEL.lua.Currency = MODEL.regional.current_language.currency()
  end
  if MODEL.other.debug() then
    obs_saved_parameters_modified = var.observer({MODEL = MODEL.route.parameters_modified, ONCHANGE = function()
      if MODEL.route.parameters_modified() then
        ASSERT(MODEL.route.vehicle_type() == MODEL.mydata.vehicle_profile.list[MODEL.mydata.vehicle_profile.selected_profile()].vehicle_type())
      else
        MODEL.route.list.navigated.settings.check_consistency_with_global_settings()
        sc_CheckOffroadParams()
      end
    end
    , TRIGGER_ON_START = false})
  end
  if gSkinDebug then
    REGISTERKEYCODE("PREVTHEME", 33)
    KEY("PREVTHEME", sc_SelectPrevTheme)
    REGISTERKEYCODE("NEXTTHEME", 34)
    KEY("NEXTTHEME", sc_SelectNextTheme)
  end
    if gSchemeDebug then
        REGISTERKEYCODE("PREVSCHEME", 35)
        KEY("PREVSCHEME", sc_MapColorSchemePrev_debug)
        REGISTERKEYCODE("NEXTSCHEME", 36)
        KEY("NEXTSCHEME", sc_MapColorSchemeNext_debug)
    end
  MODEL.mydata.tracks.show_on_map = false
  MODEL.route.list.navigated.waypoints.autocreate_start = true
  MODEL.screen.msgbox.pause_tags("popup", true)
  MODEL.regional.keyboard.update_panel_list()
  lm_CockpitList.no_route:append(lm_CockpitList[vCockpitFieldNoRoute1()], lm_CockpitList[vCockpitFieldNoRoute2()], lm_CockpitList[vCockpitFieldNoRoute3()])
  lm_CockpitList.has_route:append(lm_CockpitList[vCockpitField1()], lm_CockpitList[vCockpitField2()], lm_CockpitList[vCockpitField3()])

  local no_route_closed_id = _G["vCockpitFieldNoRoute" .. tostring(vCockpitFieldNoRouteClosed())]()
  lm_CockpitList.no_route_closed:append(lm_CockpitList[no_route_closed_id]) 
  local has_route_closed_id = _G["vCockpitField" .. tostring(vCockpitFieldClosed())]()
  lm_CockpitList.has_route_closed:append(lm_CockpitList[has_route_closed_id])
  
  if MODEL.route.list.navigated.waypoints.start_is_user_selected() then
    MODEL.gps.stop()
    MODEL.navigation.car.position = MODEL.route.list.navigated.waypoints.list[0].real_position()
  else
    MODEL.gps.start()
  end
  sc_UpdateOffroadModelsFromUI()
 ----------- MODEL.other.trips[0].reset()
  sc_enable_offroute_recalc()
  EXEC_STARTUP_PARAMS()
  MODEL.lua.HasPictureViewerLic = MODEL.other.license.has_license_for_module(1107296319)
  if MODEL.lua.HasPictureViewerLic() and MODEL.oasis.pictures.slideshow_time() == 0 then
    MODEL.oasis.pictures.slideshow_time = 5
  end
  sc_SetCountrySpecTMCIcon()
  MODEL.mydata.history.sort_smart()
  sc_SetEasyDefaulSett()
  sc_Map_States_Init()
  sc_vehicle_size()
    if sc_start_customize ~= nil then
        sc_start_customize()
    end
  MODEL.lua.dateDelimiter = MODEL.regional.dateformat() % 3
  MODEL.lua.dateFormat = MODEL.regional.dateformat() / 3
  obs_AutoTimeZoneError:START()
  sc_TMC_SearchResult()
  if MODEL.EXISTS.tmc.src.http.enabled() then
    MODEL.lua.OnlineTrafficExists = true
    if MODEL.network.supported() and MODEL.tmc.src.http.enabled() then
      obs_OnlineTrafficError.TRIGGER_ON_START = true
      obs_OnlineTrafficError:START()
    else
      MODEL.tmc.src.http.enabled = false
    end
  else
    MODEL.lua.OnlineTrafficExists = false
  end
  sc_ManualDetourGetter()
  if vLastDayColorProfile() ~= "" or MODEL.interface.colorprofile.day_list[MODEL.interface.colorprofile.day_list.index()].original_name() == "COLORSCHEME~Minimal" then
    local DayIndex = MODEL.interface.colorprofile.day_list.find_by_name(translate(vLastDayColorProfile()))
    local NightIndex = MODEL.interface.colorprofile.night_list.find_by_name(translate(vLastNightColorProfile()))
    if DayIndex == -1 then
      DayIndex = 0
    end
    if NightIndex == -1 then
      NightIndex = 0
    end
    MODEL.interface.colorprofile.day_list.index = DayIndex
    MODEL.interface.colorprofile.night_list.index = NightIndex
    ui.vLastDayColorProfile = ""
    ui.vLastNightColorProfile = ""
  end
  ATTACHANIMLAYER(uieffect)
  sc_Set_DayNightMode()
  MODEL.navigation.watched_restrictions = bit.bor(EWatchedRestrictions.Vehcile, EWatchedRestrictions.SoftTruck, EWatchedRestrictions.HardTruck)
  if PERSISTENT.vfirst_start_default_settings() then
    sc_first_start_default_settings()
  end
    sc_BuildMapLocalMenu()
    ui.fullMapLocalMenuList:sort("menu_index")
  MODEL.ui.lmHighwaySettings.resize(4)
  MODEL.ui.lm_trackColor.resize(16)
  MODEL.lua.truckLicensed = MODEL.EXISTS.mydata.truck()
  MODEL.oasis.travel.initialize_data()
  if MODEL.lua.vEasyWizModeOnFirstStart() then
    sc_btnASM_ConfigWizard_OnRelease()
  else
    sc_GoToStartState(false)
    MODEL.lua.StartupVP = true
    gVSelect = sc_GetSysEntry("interface", "vehicle_selection", false)
    if sc_GetSysEntry("interface", "vehicle_selection_truck_only", true) then
      if MODEL.route.vehicle_type() == 3 and MODEL.lua.truckLicensed() then
        if gVSelect then
          sc_NextStateAnim(st_SettingVehicle, "fade", 1, "")
        else
          sc_EditCurrentVehicleProfile()
        end
      else
        MODEL.lua.StartupVP = false
      end
    elseif gVSelect then
      sc_NextStateAnim(st_SettingVehicle, "fade", 1, "")
    else
      sc_EditCurrentVehicleProfile()
    end
  end
  sc_SetVehicleSpecificSettings()
  sc_StartParkingAD()
  obs_Tunnel:START("NO_TRIGGER")
  obs_destination:START("NO_TRIGGER")
  obs_TruckWaiting_Starter:START("NO_TRIGGER")
  sc_StartCheckingRestrictions()
  if MODEL.EXISTS.other.slapi() then
    obs_slapi_routecalculated:START("NO_TRIGGER")
  end
  MODEL.route.histspeed.use_timeslice = false
  MODEL.navigation.car.map_provider_change_handler = sc_MapProviderChanged
  ui_MapLocalMenuListLayer.X = uiResW
  gUserPOI_Provider = MODEL.poi.find_provider("userpoi")
  gROPoi_Provider = MODEL.poi.find_provider("ropoi")
  local exitTimeout = sc_GetSysEntry("debug", "exit_timeout", -1)
  if exitTimeout ~= -1 then
    doDelayed(50 * exitTimeout, sc_DoExit)
  else
    local restartTimeout = sc_GetSysEntry("debug", "restart_timeout", -1)
    if restartTimeout ~= -1 then
      doDelayed(50 * restartTimeout, sc_Restart)
    end
  end
  if MODEL.EXISTS.other.license.subscriptions.ui_is_ready() then
    MODEL.other.license.subscriptions.ui_is_ready = true
  end
    if MODEL.lua.CockpitType() == 2 then
        MODEL.lua.vEasyNavTripInfoOpen = true
end
    if MODEL.lua.ForceRealTimeCollect() then
        sc_ForceRealTimeCollect()
    end
end

--gj trip info buttons fix -----------------------
sc_AutoCloseCockpit_orig = sc_AutoCloseCockpit
sc_AutoCloseCockpit = function()
  gCockpitAutoClosed = true
  nTiopen = MODEL.lua.vEasyNavTripInfoOpen()
  if (MODEL.lua.CockpitType() == 0 or MODEL.lua.CockpitType() == 1) and MODEL.lua.vEasyNavTripInfoOpen() and not gCockpitJustOpened then
    MODEL.lua.vEasyNavTripInfoOpen = false
  end
end
 
sc_ReopenCockpit_orig = sc_ReopenCockpit
sc_ReopenCockpit = function()
  if nTiopen and gCockpitAutoClosed then
    MODEL.lua.vEasyNavTripInfoOpen = true
  end
  gCockpitAutoClosed = false
end

--gj junction -----------------------

sc_NewJunctionView_orig = sc_NewJunctionView
sc_NewJunctionView = function()
  MODEL.lua.JunctionViewHiddenByUser = false
  MODEL.navigation.new_junctionview = false
  if bLaneinfoSignpostValid() then
    sc_SignPostLayerShow()
  end
  if not MODEL.navigation.car_in_tunnel() then
	sc_AutoCloseCockpit()
  end
end

sc_JunctionViewOnhide_orig = sc_JunctionViewOnhide
sc_JunctionViewOnhide = function()
  if st_EasyNav.isActive then
    MODEL.screen.msgbox.resume_tags("popup")
  end
  sc_ReopenCockpit()
end


-- gj poi Visibility
wCurrentGroup = 0
wCurrentGroupFav = -1
wAddPOIposition	= 0
wGroupIcon = nil
wGroupIconVisibility = nil
wGroupInheritVisibility = nil
wGroupNameVisibility = nil
wGroupDistanceVisibility = nil

createState("st_ManagePOIGroupVisibility")
st_ManagePOIGroupVisibility:useLayers(ui_Title, ui_Status, ui_Background, ui_ManagePOIGroupVisibility, uieffect)
st_ManagePOIGroupVisibility.init = function()
	txtTitle.TEXT = m_i18n("Set Place Visibility")
end
 
st_ManagePOIGroupVisibility.exit = function()
	sc_wUserPOISearchParams_CheckRemoved()
end
 
 sc_ManagePOIGroupVisibility = function()
	wCurrentGroup = MODEL["*"].id()
	MODEL.lua.wSettingDistOn = MODEL["*"].writable()
	MODEL.lua.wSettingDistVisual = MODEL["*"].icon()
	MODEL.lua.wSettingDistSound = MODEL["*"].has_child()
	MODEL.lua.wSettingDistSoundName = MODEL["*"].name()
	MODEL.my.poi.select_group(wCurrentGroup)
	MODEL.lua.wPoiGroupAltitude = MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at()
	wGroupIconVisibility = MODEL.lua.wSettingDistVisual()
	wGroupNameVisibility = MODEL.lua.wSettingDistSoundName()
	wGroupDistanceVisibility = MODEL.lua.wPoiGroupAltitude()
	wGroupInheritVisibility = MODEL.poi.inherit_visibility()
	sc_NextStateAnim(st_ManagePOIGroupVisibility, "horz_scroll", 1, "")
end

st_LoadPOIVisibilities.init_orig = st_LoadPOIVisibilities.init
st_LoadPOIVisibilities.init = function()
	MODEL.lua.wLocalMenuHide = true
	txtTitle.TEXT = m_i18n("Load Place Marker Settings")
end
 
sc_Poi_Visibilities_orig = sc_Poi_Visibilities
sc_Poi_Visibilities = function()
	sc_ForcePoiInit()
	sc_SetPoiVisibilities()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("picturepoi"))
	MODEL.lua.poi.selectedPOIVis = MODEL.poi.structure.visibility_array()
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
	sc_NextStateAnim(st_POIVisibilities, "horz_scroll", 1, "")
end 
 
st_LoadPOIVisibilities.done = function()
	MODEL.lua.wLocalMenuHide = false
end
 
sc_PoiVisibilityListClearAll_OnRelease_orig = sc_PoiVisibilityListClearAll_OnRelease
sc_PoiVisibilityListClearAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all Place Marker configurations?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_PoiVisibilityClearAll_OnRelease_OK", m_i18n("Delete All"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
st_POIVisibilities.enter_orig = st_POIVisibilities.enter
st_POIVisibilities.enter = function()
	EPoiScrollPos = {}
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
end
 
st_POIVisibilities.done_orig = st_POIVisibilities.done
st_POIVisibilities.done = function()
end
 
sc_back_POIGroupVisibility = function()
	local action = false
	if wGroupIconVisibility ~= MODEL.lua.wSettingDistVisual() then
		MODEL.my.poi.current_group.icon = MODEL.lua.wSettingDistVisual()
		action = true
	end
	if wGroupNameVisibility ~= MODEL.lua.wSettingDistSoundName() then
		local newname = L"@"..MODEL.lua.wSettingDistSoundName()
		MODEL.my.poi.rename_group(wCurrentGroup, newname, MODEL.poi.find_provider("userpoi"))
		action = true
	end
	if wGroupDistanceVisibility ~= MODEL.lua.wPoiGroupAltitude() or wGroupInheritVisibility ~= MODEL.poi.inherit_visibility() then
		MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at = MODEL.lua.wPoiGroupAltitude()
		action = true
	end
	if action then
		MODEL.poi.structure.execute()
		sc_SavePOIVisibility()
	end
	sc_back()
end

--change poi icons

createState("st_ManagePOIGroupIcon")
st_ManagePOIGroupIcon:useLayers(backgroundLayers, ui_ManagePOIGroupIcon)
st_ManagePOIGroupIcon.init = function()
	txtTitle.TEXT = m_i18n("Select Place Icon")
end

sc_ChangeCurrentPoiGroupIcon = function(group)
	wGroupIcon = group
	if not sc_GetSysEntry("poi", "sort_icons", 1) then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
	elseif MODEL.ui.list_wScreenIcons.isempty() then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
		local iconbmp, iconphase = nil, nil
		for i = 0, MODEL.screen.icons.size() - 1 do
			iconbmp, iconphase = MODEL.screen.get_icon_file_and_phase(MODEL.screen.icons[i](), 2)
			if not (string.sub(iconbmp,1,1) == "*" or string.sub(iconbmp,1,1) == ";") then
				ui.list_wScreenIcons:add({bmp=iconbmp, phase=iconphase, icon=MODEL.screen.icons[i]()})
			end
		end
		ui.list_wScreenIcons:sort("phase")
		ui.list_wScreenIcons:sort("bmp")
	end
	sc_NextStateAnim(st_ManagePOIGroupIcon, "horz_scroll", 1, "")
end

sc_CurrentPoiGroupIconSelected = function()
	if wGroupIcon then
		MODEL.lua.wSettingDistVisual = MODEL["*"].icon()
	else
		MODEL.my.poi.current.icon = MODEL["*"].icon()
	end
	sc_back()
end

--gj navigatemap.lua -------------
wTemp_overview_distance = nil

st_EasyNav.init_orig = st_EasyNav.init
st_EasyNav.init = function()
  --gj overview
  wTemp_overview_distance = nil
	
  local messageBoxY = scGetMapPopupY()
  sc_PosRecalcLayer()
  sc_Set_Presets()
  sc_init_local_menu("ui.lm_st_EasyNav")
  primary:ONMAPCLICK(sc_EasyMapClick)
  obs_enter_drag_mode:START("no_trigger")
  if MODEL.lua.dragMode() then
    sc_dragmode(true)
    MODEL.lua.mainMenuMode = false
  else
    if MODEL.navigation.is_in_simulation() then
      sc_SetFlyOverMode()
    else
      sc_set_Nav2D3D()
      MODEL.lua.mainMenuMode = false
    end
    sc_SetCockpitMap()
    sc_Set_Follow_On()
    MODEL.map.primary.show_cursor = false
  end
  ATTACH_LANEINFO(sprLaneInfoEasy, "laneinfo.ini")
  ATTACH_LANEINFO(sprLaneInfoSignpost, "laneinfo_signpost.ini")
  ui.bLaneInfoSignpostForceRedraw = 1
  local junctionViewType = sc_GetSysEntry("navigation", "junction_view_type", "NNG")
    local junctionViewContentResolution = sc_GetSysEntry("navigation", "junction_view_content_resolution_override", gJunctionViewContentResolution)
    gJunctionViewNeedsSignpost = sc_GetSysEntry("navigation", "junction_view_needs_signpost", true)
  if junctionViewType == "NNG" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory)
  elseif junctionViewType == "mixed" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory .. ";" .. junctionViewContentResolution)
  elseif junctionViewType == "NNG_NQ" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], "16_9_NQ_Roads")
  elseif junctionViewType == "NQ" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory .. ";" .. junctionViewContentResolution)
  end
    if MODEL.map.primary.state() == "2dnorthup" or MODEL.map.primary.state() == "simulate_2d_nu" then
        ui_SimulationControls:Y(uiResH * 32 / 100)
        MODEL.map.primary.car_posy = 50
    else
        ui_SimulationControls:Y(0)
        MODEL.map.primary.car_posy = 80
    end
  st_EasyNav.active = true
  obs_want_junctionview:START()
  obs_TunnelOverview:START()
  ui_Local_Menu_Background.ALPHA = 0
  ui_Local_Menu_Background_Disabled:HIDE()
  if not MODEL.map.primary.center_follow() and not gKeepMapPosAfterBack then
    MODEL.map.primary.center_noanim(MODEL.map.cursor.position())
  end
  gKeepMapPosAfterBack = false
  MODEL.mydata.tracks.show_on_map = MODEL.lua.TrackShowOnMap()
  if showDriveCarefully and MODEL.interface.drive_carefully() then
    sc_drive_carefully_init()
  end
  
  -- gj zoom overview
	
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		MODEL.map.primary.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end

	MODEL.lua.wOverviewFlag = false
	if MODEL.map.primary.camera_settings.overview_enabled() then
		wTemp_overview_distance = MODEL.map.primary.camera_settings.overview_distance()
		if not MODEL.lua.wUserZoomSetting() and MODEL.lua.wOverviewMode() == 1 then
			sc_wOverviewHighwayPause()
			obs_wOverviewHighwayFlag:START()
		else
			obs_wOverviewFlag:START("NO_TRIGGER")
		end
	end
  
  ui.vTmcButtonBlinkCounter = 0
  ui.vDAIsVisible = 1
  MODEL.traffic.events.sort_by("distance")
  sc_UpdateFullDelayTextOnMap()
  satPhaseTimerId = doDelayed(20, sc_CycleSatPhase, true)
  MODEL.lua.ismapvisible = true
  MODEL.navigation.restrictions_turn_change_handler = sc_TruckTurnRestrictionAlert
  MODEL.lua.vEasyNavMapMenuOpen = false
  if MODEL.lua.vgjShowRestTurn() and MODEL.lua.vgjSoundRestTurn() then
	ob_gj_turnrest:START("NO_TRIGGER")
	if MODEL.navigation.turn_restriction_icon.valid() then
		ob_gj_turnrest_chg:START("NO_TRIGGER")
	end
  end
  sc_gj_set_autorecalc()
  sc_NaviMenuAlphaRestore()
end

st_EasyNav.done_orig = st_EasyNav.done
st_EasyNav.done = function()
  sc_NaviMenuAlphaDown()
  sc_reset_primary(true)
  sc_SetNavCarPos(false)
  killDelayed(satPhaseTimerId)
  ui_Quick_Menu_Background.ALPHA = 0
  ui_Quick_Menu_Background_Disabled:HIDE()
  MODEL.screen.msgbox.pause_tags("popup", true)
  obs_enter_drag_mode:STOP()
  st_EasyNav.active = nil
  obs_want_junctionview:STOP()
  obs_TunnelOverview:STOP()
  -- gj zoom overview
	obs_wOverviewHighwayFlag:STOP()
	obs_wOverviewFlag:STOP()
  ATTACH_TUNNELOVERVIEW()
  MODEL.navigation.want_junctionview = false
  MODEL.mydata.tracks.show_on_map = false
  obs_user_browsing_map:STOP()
  obs_clicked_tmc_id_changed:STOP()
  ob_gj_turnrest:STOP()
  MODEL.traffic.events.sort_by(MODEL.lua.trafficEventSorting())
  MODEL.lua.ismapvisible = false
  MODEL.navigation.restrictions_turn_change_handler = nil
end
sc_set_Nav2D3D = function()
  if MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D then
    sc_Easy2D()
  elseif MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D_NU then
    sc_Easy2D_NU()
  else
    sc_Easy3D()
  end
end

-- local_menu

sc_OpenMapLocalMenu_orig = sc_OpenMapLocalMenu
sc_OpenMapLocalMenu = function()
  sc_NaviMenuAlphaRestore()
  gMapMenuBlendOutID = -1
  sc_SearchFavorites()
  MODEL.lua.vMapMenuOpen = true
  obs_CloseMapMenu:START("NO_TRIGGER")
  if gLocalMenuBlendOutID ~= -1 or gMapMenuBlendOutID ~= -1 then
    killDelayed(gLocalMenuBlendOutID)
    killDelayed(gMapMenuBlendOutID)
    MODEL.map.primary.make2stillbackground(false)
  end
  MODEL.map.primary.make2stillbackground(true)
  ui_MapLocalMenuListLayer:XBLEND(uiResW, 0, sc_GetBlendStep(32))
  ui_Quick_Menu_Background:BLENDALPHA(0, 22, sc_GetBlendStep(32))
  ui_Quick_Menu_Background_Disabled:SHOW()
end

sc_CloseMapLocalMenu_orig = sc_CloseMapLocalMenu
sc_CloseMapLocalMenu = function(Immediate)
  SAVESETTINGS()
  sc_NaviMenuAlphaRestore()
  if gMapMenuBlendOutID == -1 then
    MODEL.lua.vMapMenuManageMode = false
    doDelayed(sc_GetBlendStep(32, Immediate), function()
      MODEL.lua.vMapMenuOpen = false
    end
    )
    gMapMenuBlendOutID = doDelayed(sc_GetBlendStep(32, Immediate), function()
      MODEL.map.primary.make2stillbackground(false)
      gMapMenuBlendOutID = -1
    end
    )
    obs_CloseMapMenu:STOP()
    ui_MapLocalMenuListLayer:XBLEND(0, uiResW, sc_GetBlendStep(32, Immediate))
    ui_Quick_Menu_Background:BLENDALPHA(22, 0, sc_GetBlendStep(32, Immediate))
    ui_Quick_Menu_Background_Disabled:HIDE()
  end
end
 

sc_EasyMapClick_orig = sc_EasyMapClick
sc_EasyMapClick = function()
  sc_wBlockCheck()

  local selectedPois = MODEL.map.primary.clicked_poi_list
  if #selectedPois == 1 then
    currentPoi = selectedPois[0]
    MODEL.my.poi.select_poi(currentPoi.provider_id(), currentPoi.id())
  end
  PoiSelected = false
  gClickedPoiFlag = false
  if #selectedPois and (MODEL.map.primary.zoom():toInt() <= gPoiDistantDistance or st_ShowPoiResultOnMap.isActive) then
    sc_SetPOICursorIcon()
    PoiSelected = true
    gClickedPoiFlag = true
    g_cursor_strapped = true
  elseif MODEL.map.primary.clicked_tmc_id.valid() then
    MODEL.map.primary.cursor_icon = "cursor_tmc"
    g_cursor_strapped = true
  elseif #MODEL.map.primary.clicked_speedcam_list then
    MODEL.map.primary.cursor_icon = "cursor_speedcam"
    g_cursor_strapped = true
    sc_UpdateSpeedcamModels(MODEL.map.primary.clicked_speedcam_list[0])
  else
    MODEL.map.primary.cursor_icon = "cursor"
    g_cursor_strapped = false
  end
  if MODEL.map.primary.center_follow() then
    obs_enter_drag_mode:STOP()
    sc_dragmode(false)
    obs_enter_drag_mode:START("NO_TRIGGER")
  end
end


--gj zoom overview----------------
wInpValueInteger_min = 0
wInpValueInteger_max = 0
wInpValueInteger_needsign = false
wInpValueInteger_model = ""
wTmpdateDelimiter = nil
wUnitConvMeter2Unit = {float.new("1.093613298"), float.new("1.0"), float.new("3.280839895")}


createState("st_InputValueInteger")
st_InputValueInteger:useLayers(backgroundLayers, ui_InputValueInteger)
st_InputValueInteger.init = function()
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_name(L"Core Numbers")
	MODEL.lua.InputValidatorIsDate = true
	wTmpdateDelimiter = MODEL.lua.dateDelimiter()
	MODEL.lua.dateDelimiter = 0
end
 
st_InputValueInteger.done = function()
	KEY("RETURN")
	MODEL.regional.keyboard.on_close_panel()
	MODEL.regional.keyboard.smartkey_model("")
end
 
sc_inpValueInteger_onchange = function()
	local inptext = ui.inpValueInteger.VALUE()
	local tempinptext = wstring.sub(inptext, 1, 1) == L"-" and wstring.sub(inptext, 2, #inptext) or inptext
	local acceptable, InputKeys = getNextInput_Int(tempinptext, wInpValueInteger_min, wInpValueInteger_max)
	MODEL.lua.keyb_done = acceptable
	MODEL.lua.fuelinputkeys = InputKeys .. (#inptext == 0 and wInpValueInteger_needsign and L"-" or L"")
	MODEL.regional.keyboard.smartkey_model("lua.fuelinputkeys")
end
 
sc_SelectValueInteger = function(title, donefunction, min, max, needsign, donemodel)
	wInpValueInteger_min = min
	wInpValueInteger_max = max
	wInpValueInteger_needsign = needsign
	if donemodel ~= nil then
		wInpValueInteger_model = donemodel
	end
	local emptytitle = (needsign and (L"-" .. towstring(max)) or towstring(min)) .. L".." .. towstring(max)
	sc_NextStateAnim(st_InputValueInteger, "horz_scroll", 1, "")
	txtTitle.TEXT = m_i18n(title)
	inpValueInteger.value = L""
	inpValueInteger.EMPTYTITLE = translated_format(m_i18n("<Enter Number (%s)>"), emptytitle)
	sc_inpValueInteger_onchange()
	KEY("RETURN", donefunction)
	ui.vKeyTableDone = donefunction
end
 
inpValueInteger_isempty = function()
	local result = var.new()
	inpValueInteger:ISEMPTY(result)
	return result()
end

-- overview zoom
 
sc_ExitOverview = function()
	MODEL.map.primary.camera_settings.overview_distance = 9999999
end

sc_wOverviewHighwayPause = function()
	MODEL.map.primary.camera_settings.overview_distance = 9999999
end

sc_wOverviewReset = function()
	if MODEL.map.primary.camera_settings.overview_distance() == 9999999 and wTemp_overview_distance ~= nil then
		MODEL.map.primary.camera_settings.overview_distance = wTemp_overview_distance
	end
end
 
sc_overview_check = function()
	MODEL.lua.wOverviewFlag = (wTemp_overview_distance < MODEL.navigation.distance_to_maneuver())
end

sc_jgOverview_on_off = function()
	if MODEL.map.primary.camera_settings.overview() then 
		sc_ExitOverview()
	else
		sc_wOverviewReset()
	end	
end


sc_MapSettings_Zoom = function()
	sc_NextStateAnim(st_MapSettings_Zoom, "horz_scroll", 1, "")
end

sc_ConvertInputDistToCurrent = function(dist)
	return float.toInt(float.new(tostring(dist)) * wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
end
 
sc_Select_wZoom_minangleDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_minangle = text
		if MODEL.lua.wZoom_maxangle() < text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_maxangleDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangle = text
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_maxangleSPDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangleSP = text
		if MODEL.lua.wZoom_maxangle() > text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_speedlowDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = regional.units:convert("Speed", "km/h", text, "miles/hour")
			text = double.round(text):toInt()
		end
		MODEL.lua.wZoom_speedlow = text
		if MODEL.lua.wZoom_speedhigh() < text then
			MODEL.lua.wZoom_speedhigh = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_speedhighDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = regional.units:convert("Speed", "km/h", text, "miles/hour")
			text = double.round(text):toInt()
		end
		MODEL.lua.wZoom_speedhigh = text
		if MODEL.lua.wZoom_speedlow() > text then
			MODEL.lua.wZoom_speedlow = text
		end
	end
	PREVSTATE()
end

sc_SelectIntegerDistanceDone = function()
	if not inpValueInteger_isempty() then
		MODEL[wInpValueInteger_model] = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end

sc_SelectIntegerNumberDone = function()
	if not inpValueInteger_isempty() then
		MODEL[wInpValueInteger_model] = tonumber(ui.inpValueInteger.VALUE())
	end
	PREVSTATE()
end

createState("st_MapSettings_Zoom")
st_MapSettings_Zoom:useLayers(backgroundLayers, ui_List_Background, ui_MapSettings_Zoom)
st_MapSettings_Zoom.init = function()
	txtTitle.TEXT = m_i18n("User zoom settings")
end


sc_RestoreSmartZoom_orig = sc_RestoreSmartZoom
sc_RestoreSmartZoom = function()
	MODEL.lua.showLaneInfo = true
	sc_Angle_notSP()
end


st_MapSettings_Zoom.exit = function()
	sc_Set_Presets()
end


sc_Angle_SP = function()
	local camerasettings = MODEL.map.primary.camera_settings()
	camerasettings.restore()
	camerasettings.roundabout.centery = 65
	camerasettings.presetid = 10 * (MODEL.lua.vEasyViewMode() + 1) + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		camerasettings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
		camerasettings.maxangle = MODEL.lua.wZoom_maxangleSP()
		camerasettings.angleoffset = MODEL.lua.wZoom_maxangleSP()
		camerasettings.defaultangle = MODEL.lua.wZoom_maxangleSP()
	else
		camerasettings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Angle_notSP = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.camera_settings.restore()
	mapLayer.camera_settings.roundabout.centery = 50
	mapLayer.car_posy = (MODEL.lua.vEasyMapMode() == EMapMode.Mode_3D and 80 or (MODEL.lua.vEasyMapMode() == 3 and 50 or (MODEL.route.vehicle_type() == EVehicleType.Pedestrian and 70 or 80)))
	mapLayer.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		mapLayer.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
 
sc_Set_Presets_orig = sc_Set_Presets
sc_Set_Presets = function()
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets()
	end
	MODEL.map.primary.camera_settings.restore()
	MODEL.map.primary.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		MODEL.map.primary.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Set_wUser_Presets = function()
	local settings = MODEL.map.primary.camera_settings()
	sc_Set_wUser_Presets_followzoom()
	settings.minangle = MODEL.lua.wZoom_minangle()
	settings.maxangle = MODEL.lua.wZoom_maxangle()
	settings.angleoffset = MODEL.lua.wZoom_maxangle()
	settings.defaultangle = MODEL.lua.wZoom_maxangle()
	settings.lowspeed = MODEL.lua.wZoom_speedlow()
	settings.highspeed = MODEL.lua.wZoom_speedhigh()
	if not MODEL.lua.wZoom_lockzoom() then
		settings.speedzoom = MODEL.lua.wZoom_speedzoom()
		if MODEL.lua.wZoom_speedzoom() then
			settings.speedzoom_use_minmax = true
		end
	end
	settings.speedangle = MODEL.lua.wZoom_speedangle()
	if MODEL.lua.wZoom_speedangle() then
		settings.speedangle_use_minmax = true
	end
	settings.overview_enabled = MODEL.lua.wZoom_overview_enabled() and not MODEL.lua.wZoom_lockzoom()
	if MODEL.lua.wZoom_overview_enabled() then
		settings.overview_distance = MODEL.lua.wZoom_overview_distance()
		settings.overview_zoom2d = MODEL.lua.wZoom_overview_zoom2d()
		settings.overview_zoom3d = MODEL.lua.wZoom_overview_zoom3d()
		settings.overview_angle = MODEL.lua.wZoom_overview_angle()
	end
end
 
sc_Set_wUser_Presets_followzoom = function()
	if MODEL.lua.wUserZoomSetting() and MODEL.lua.wZoom_lockzoom() then
		MODEL.map.primary.zoom_follow = false
		MODEL.map.primary.zoom = (MODEL.map.primary.mode() == "3d" and MODEL.lua.wZoom_defaultzoom3d() or MODEL.lua.wZoom_defaultzoom2d())
	else
		MODEL.map.primary.zoom_follow = not MODEL.lua.dragMode()
	end
end
 
sc_Easy3D_orig = sc_Easy3D
sc_Easy3D = function()
	local mapLayer = MODEL.map.primary()
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("navmap3d", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_3D()
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
end
 
sc_Easy2D_orig = sc_Easy2D
sc_Easy2D = function()
	local mapLayer = MODEL.map.primary()
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dheadup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
		mapLayer.zoom_follow = false
		mapLayer.car_posy = 70
		mapLayer.center_posy = 70
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.car_posy = 80
		mapLayer.center_posy = 80
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end

sc_Easy2D_NU = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dnorthup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
	end
	mapLayer.zoom_follow = true
	mapLayer.car_posy = 50
	mapLayer.center_posy = 50
	if not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.center_follow = true
		mapLayer.rotate = 0
		mapLayer.rotate_follow = false
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end
 
sc_Easy3DFromDragmode_orig = sc_Easy3DFromDragmode
sc_Easy3DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("navmap3d", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
		mapLayer.rotate_follow = false
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
		mapLayer.rotate_follow = true
	end
end
 
sc_Easy2DFromDragmode_orig = sc_Easy2DFromDragmode
sc_Easy2DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dheadup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.breadcrumbs = true
		mapLayer.center_posy = 50
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.breadcrumbs = false
		mapLayer.center_posy = 80
	end
end

sc_Easy2D_NU_FromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dnorthup", 1)
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
	sc_Set_wUser_Presets_followzoom()
	mapLayer.center_posy = 50
	mapLayer.car_posy = 50
end
 
sc_set_3dDem = function()
	local value = MODEL.map.primary["3d_dem"]()
	local valueNeg = 0
	if value == 0 then
		valueNeg = 3
	end
	MODEL.map.primary.setglobal = true
	MODEL.map.primary.setglobal_filter = wGetNUSupported and "navmap3d,2dheadup,2dnorthup,simulate,simulate_2d,simulate_2d_nu" or "navmap3d,2dheadup,simulate,simulate_2d"
	MODEL.map.primary["3d_dem"] = valueNeg
	MODEL.map.primary["3d_dem"] = value
	MODEL.map.primary.setglobal = false
end

sc_backFromdragmode_orig = sc_backFromdragmode
sc_backFromdragmode = function()
  obs_InvalidateClickedListEvent:STOP()
  nextRotate = 0
  MODEL.lua.dragMode = false
  MODEL.map.primary.autochange_mode_for_zoom = true
  obs_Dragmode_Type:STOP()
  sc_SetCockpitMap()
  if g_MapModeBeforeDragMode > -1 then
	MODEL.lua.vEasyMapMode = g_MapModeBeforeDragMode
	g_MapModeBeforeDragMode = -1
  end
  if MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D then
    sc_Easy2DFromDragmode()
  elseif MODEL.lua.vEasyMapMode() == 3 then
		sc_Easy2D_NU_FromDragmode()
  else
    sc_Easy3DFromDragmode()
  end
  if MODEL.lua.dragMode() or not MODEL.lua.HwyPoiListIsVisible() then
    local isPanelOpen = MODEL.screen.msgbox.is_onscreen()
  end
  sc_SetNavCarPos(isPanelOpen)
end

sc_ChangeFlyOverModeState = function()
	local mapLayer = MODEL.map.primary
	mapLayer.save_state(mapLayer.state())
	local next_state = MODEL.lua.vEasyMapMode() == 3 and "simulate_2d_nu" or (MODEL.lua.vEasyMapMode() == 2 and "simulate_2d" or "simulate")
	mapLayer.switch_state(next_state,1)
	mapLayer.rotate_follow = MODEL.lua.vEasyMapMode() ~= 3
	if MODEL.lua.vEasyMapMode() == 3 then
		mapLayer.rotate = 0
	else
		mapLayer.rotate = 4096 - MODEL.navigation.car.heading()
	end
	primary:ONMAPCLICK(sc_ShowHideSimulateControls)
	primary:ONMAPDRAGGED(sc_ShowHideSimulateControls)
	sc_ShowHideSimulateControls()
end
 
sc_Set_Follow_On_orig = sc_Set_Follow_On
sc_Set_Follow_On = function()
	local mapLayer = MODEL.map.primary()
	if MODEL.route.vehicle_type() ~= EVehicleType.Pedestrian then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
	mapLayer.center_follow = true
	mapLayer.rotate_follow = mapLayer.state() ~= "2dnorthup" and mapLayer.state() ~= "simulate_2d_nu"
	if mapLayer.state() == "2dnorthup" or mapLayer.state() == "simulate_2d_nu" then
		mapLayer.rotate = 0
	end
end 
--bluetooth
sc_Show_BTSettings_orig = sc_Show_BTSettings
sc_Show_BTSettings = function()
	if MODEL.other.bluetooth.available() then
		MODEL.other.bluetooth.show_manager()
	else
		local gjmBTapp = var.new()
		local gjmBTpar = var.new()
		gjmBTapp = sc_GetSysEntry("bluetooth", "btappl", "btonoff.exe")
		gjmBTpar = sc_GetSysEntry("bluetooth", "btparam", "")
		doDelayed(5, function()
			START_APPLICATION(gjmBTapp,gjmBTpar)
		end
		)
		sc_back_to_cockpit()
	end
end

--block
wBlockedFromCockpit = false


sc_ChangeBlockedRoadOK_onrelease_orig = sc_ChangeBlockedRoadOK_onrelease   
sc_ChangeBlockedRoadOK_onrelease = function()
  sc_BlockedRoadsData_SaveToCurrent()
  CLEARTOSTATE(st_FindOnMap)
  if st_FindOnMap.isEntered then
    CLEARTOSTATE(st_FindOnMap)
  else
    CLEARTOSTATE(st_SetBlockedRoads)
  end
  MODEL.lua.newBlockedSection = false
    
   sc_wBlockCheck() 
  if MODEL.lua.dragMode() then 
    sc_BlockedRoadsData_SetDefaults() 
    sc_back()
  end
  
end


sc_ChangeBlockedRoadBACK_onrelease_orig = sc_ChangeBlockedRoadBACK_onrelease   
sc_ChangeBlockedRoadBACK_onrelease = function()
  if MODEL.lua.newBlockedSection() then
    MODEL.mydata.blocked_roads.delete_current()
    MODEL.lua.newBlockedSection = false
  end
  sc_wBlockCheck() 
  sc_back()
end


sc_wBlockCheck = function()
	MODEL.lua.wBlockValid = MODEL.route.is_segment_roadblock(MODEL.map.cursor.position(), 50)
	MODEL.lua.vgjBlockMenuOpen = false
end

sc_BlockRoadSectionPermanent_orig = sc_BlockRoadSectionPermanent
sc_BlockRoadSectionPermanent = function()
	MODEL.route.add_roadblock(MODEL.map.cursor.position(), true, true)
	MODEL.mydata.blocked_roads.current_weekdays_all_blocked(true)
	sc_wBlockCheck()
end

sc_LMBlockRoadCurrentUsageFind = function()
	if sc_wBlockRoadCurrentItemFind() then
		sc_BlockedRoadsData_LoadFromCurrent()
		NEXTSTATE(st_ChangeBlockedRoad)
	else
		NEXTSTATE(st_SetBlockedRoads)
	end
	sc_wBlockCheck()
end
 
sc_wBlockRoadCurrentItemFind = function()
	MODEL.route.add_roadblock(MODEL.map.cursor.position(), true, true)
	MODEL.mydata.blocked_roads.current_weekdays_all_blocked(false)
	MODEL.mydata.blocked_roads.list.setcurrent(0)
	local topLeftNeed, bottomRightNeed = MODEL.mydata.blocked_roads.get_boundrect()
	local topLeft, bottomRight = nil, nil
	local successfind = false
	MODEL.mydata.blocked_roads.delete_current()
	for i = 0, MODEL.mydata.blocked_roads.list.size() - 1 do
		MODEL.mydata.blocked_roads.list.setcurrent(i)
		topLeft, bottomRight = MODEL.mydata.blocked_roads.get_boundrect()
		if topLeft == topLeftNeed and bottomRight == bottomRightNeed then
			successfind = true
			break
		end
	end
	return successfind
end

sc_wDeleteSegmentMSG = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Delete this roadblock?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wDeleteSegment", m_i18n("Delete"), "", "ico_Delete_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wDeleteSegment = function()
	if sc_wBlockRoadCurrentItemFind() then
		MODEL.mydata.blocked_roads.delete_current()
	else
		MODEL.route.remove_roadblock(MODEL.map.cursor.position())
		MODEL.route.recalculate()
	end
	sc_wBlockCheck()
end

 
sc_BlockRoadSectionPermanent_lc = function()
	MODEL.route.add_roadblock(MODEL.map.cursor.position(), true, true)
	MODEL.lua.newBlockedSection = true
	CLEARTOSTATE(st_FindOnMap)
	NEXTSTATE(st_ChangeBlockedRoad)
end
 
sc_BlockedRoadDays_SetDay_orig = sc_BlockedRoadDays_SetDay
sc_BlockedRoadDays_SetDay = function(day_index)
	if MODEL.ui.blocked_roads_dayusage[day_index].usage() == 0 then
		blocked_roads.dayranges[day_index] = {Range1 = {Start = 0, End = 24}, Range2 = {Start = -1, End = -1}}
	else
		blocked_roads.dayranges[day_index] = {Range1 = {Start = -1, End = -1}, Range2 = {Start = -1, End = -1}}
	end
	sc_BlockedRoadsData_RefreshDayUsage(day_index)
end
 
sc_BlockedRoadsData_RefreshDayUsage_orig = sc_BlockedRoadsData_RefreshDayUsage
sc_BlockedRoadsData_RefreshDayUsage = function(day_index)
	local weekday = blocked_roads.dayranges[day_index]
	if weekday.Range1.Start == -1 then
		MODEL.ui.blocked_roads_dayusage[day_index].usage = blocked_roads.usage.off
	elseif weekday.Range1.Start == 0 and weekday.Range1.End == 24 then
		MODEL.ui.blocked_roads_dayusage[day_index].usage = blocked_roads.usage.full_time
	else
		MODEL.ui.blocked_roads_dayusage[day_index].usage = blocked_roads.usage.part_time
	end
end
 
sc_BlockedRoadDays_ChangeTime_orig = sc_BlockedRoadDays_ChangeTime
sc_BlockedRoadDays_ChangeTime = function(day_index)
	MODEL.mydata.blocked_roads.current_weekdays.index = day_index
	MODEL.ui.blocked_roads_dayusage.index = day_index
	NEXTSTATE(st_SetBlockingTime)
end
 
sc_GetBlockRoadStatus_orig = sc_GetBlockRoadStatus
sc_GetBlockRoadStatus = function()
	local text = ""
	if not MODEL.mydata.blocked_roads.list[MODEL.mydata.blocked_roads.list.index()].is_permanent() then
		text = "blocked for current route"
	else
		for day_index = 0, 6 do
			if MODEL.ui.blocked_roads_dayusage[day_index].usage() ~= blocked_roads.usage.full_time then
				text = "intermittently blocked"
			end
		end
		if text == "" then
			text = "completely blocked"
		end
	end
	return text
end

------------------

sc_wBlockRoute_OnRelease = function()
	sc_close_local_menu()
	sc_NextStateAnim(st_wBlockRoute, "fade", 1, "")
end
 
wBlockRouteStart = nil
wBlockRouteEnd = nil
createState("st_wBlockRoute")
st_wBlockRoute:useLayers(ui_wBlockRoute, primary, uieffect)
st_wBlockRoute.enter = function()
	if not MODEL.EXISTS.route.list.wblockroute() then
		MODEL.route.create_route_model("wblockroute")
	end
	wBlockRouteStart = nil
	wBlockRouteEnd = nil
	MODEL.lua.wBlockRoutePoint = 0
	MODEL.lua.wBlockRouteStatus = 0
	MODEL.lua.wBlockRouteDir = 2
	MODEL.my.map.select_address(MODEL.navigation.car.position())
	sc_SaveTempPos()
	MODEL.map.primary.cursor_icon = "cursor_places"
end
 
st_wBlockRoute.init = function()
	local mapLayer = MODEL.map.primary
	mapLayer.save_state(mapLayer.state())
	mapLayer.enter_state("browsemap")
	mapLayer.rotate = 0
	mapLayer.zoom = mapLayer.minzoom2d()
	mapLayer.breadcrumbs = false
	mapLayer.center = MODEL.my.map.selected_item.position()
	primary:ONMAPCLICK(sc_wBlockRouteClick)
	mapLayer.show_cursor = false
end
 
st_wBlockRoute.done = function()
	MODEL.map.primary.exit_state()
end
 
st_wBlockRoute.exit = function()
	MODEL.route.list.wblockroute.clear()
	MODEL.map.primary.clear_clicked_lists()
end
 
sc_wBlockRouteClick = function()
	if not st_wBlockRoute.isActive then
		return
	end
	MODEL.map.primary.show_cursor = true
	MODEL.route.list.wblockroute.create_empty_route()
	if MODEL.lua.wBlockRoutePoint() then
		wBlockRouteEnd = MODEL.map.cursor.position()
	else
		wBlockRouteStart = MODEL.map.cursor.position()
	end
	MODEL.lua.wBlockRouteStatus = 1
	MODEL.my.map.select_gcoor(wBlockRouteStart)
	MODEL.route.list.wblockroute.waypoints.set_start()
	if wBlockRouteStart and wBlockRouteEnd then
		MODEL.my.map.select_gcoor(wBlockRouteEnd)
		MODEL.route.list.wblockroute.waypoints.add_destination()
		if MODEL.route.list.wblockroute.calculation_finished() then
			sc_wBlockRouteCalculated()
		else
			obs_wblockroute_calculated:START("NO_TRIGGER")
		end
	end
end
 
sc_wBlockRouteCalculated = function()
	obs_wblockroute_calculated:STOP()
	MODEL.route.list.wblockroute.show_on_map = true
	MODEL.route.list.wblockroute.draw_flags = true
	MODEL.map.primary.route_model = "navigated,PL1,PL2,PL3,PL4,wblockroute"
	MODEL.lua.wBlockRouteStatus = 2
	doDelayed(1, sc_wBlockRoute_Fit)
end
 
sc_wBlockRoute_Fit = function()
	local gcTL, gcBR, succ = MODEL.route.list.wblockroute.get_bounding_box()
	if succ then
		sc_routemenu_info_fit_open_from_main(gcTL, gcBR)
	end
end
 
sc_wBlockRoute_Center = function()
	MODEL.map.primary.rotate = 0
	sc_LoadTempPos()
	local Pos = MODEL.my.map.selected_item.position()
	MODEL.map.cursor.position = Pos
	MODEL.map.primary.center = Pos
	MODEL.map.primary.cursor_icon = "cursor_places"
end
 
sc_wBlockRouteSave = function()
	local name = MODEL.lua.wBlockRouteDir() == 2 and "Both directions" or (MODEL.lua.wBlockRouteDir() == 1 and "Opposite direction" or "Direct direction")
	name = wstring.gsub(MODEL.route.list.wblockroute.waypoints.list[0].longname(), L"\n", L" ") .. L"\n" .. wstring.gsub(MODEL.route.list.wblockroute.waypoints.list[1].longname(), L"\n", L" ") .. L"\n" .. translated_format(m_i18n(name))
	MODEL.route.block_route("wblockroute", name, true, MODEL.lua.wBlockRouteDir())
	PREVSTATE()
	wBlockedFromCockpit = true
	NEXTSTATE(st_wBlockedRoadItem)
end
 
 
sc_wDelBlockedRoad = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Delete this roadblock?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_DelBlockedRoadOK", m_i18n("Delete"), "", "ico_Delete_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_DelBlockedRoadOK = function()
	MODEL.mydata.blocked_roads.delete_current()
	sc_back()
	if MODEL.mydata.blocked_roads.list.isempty() then
		sc_back()
	end
end
 
----------------- 
 
sc_gjBlockMenuOpen = function()
	MODEL.lua.vgjBlockMenuOpen = not MODEL.lua.vgjBlockMenuOpen()
    killDelayed(gjopenblockmen)
    gjopenblockmen = doDelayed(300, function()
		MODEL.lua.vgjBlockMenuOpen = false
	end
	)
end

sc_SetAvoidRoute_onrelease_orig = sc_SetAvoidRoute_onrelease
sc_SetAvoidRoute_onrelease = function()
  sc_close_local_menu()
  NEXTSTATE(st_SetBlockedRoads)
  MODEL.lua.vgjBlockMenuOpen = false
end

-- route.lua

sc_btnSim_Stop_Easy_onrelease_orig = sc_btnSim_Stop_Easy_onrelease
sc_btnSim_Stop_Easy_onrelease = function(HwKey)
  if not HwKey then
    uieffect:GRAB()
  end
  if MODEL.lua.simulateIsDemo() then
    demoRouteLoop = false
  else
    primary:ONMAPCLICK(sc_EasyMapClick)
  end
  local primary = MODEL.map.primary
  if primary.state() == "simulate_2d" or primary.state() == "simulate" then
    obs_enter_drag_mode:STOP()
    primary.exit_state()
    obs_enter_drag_mode:START("NO_TRIGGER")
  else
    ASSERT(false, "Not in simulation mapstate?")
  end
  MODEL.route.stop_simulation()
  MODEL.navigation.autoreplan = true
  MODEL.navigation.car.is_on_highway = false
  MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
  sc_gj_set_autorecalc()
  if not HwKey then
    uieffect:DO_ANIM("fade", 1, "")
  end
end

sc_3DFlyOverModeOff_Easy_orig = sc_3DFlyOverModeOff_Easy
sc_3DFlyOverModeOff_Easy = function()
  obs_flyover_stopped:STOP()
  MODEL.navigation.autoreplan = true
  MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
  sc_gj_set_autorecalc()
  if MODEL.lua.simulateIsDemo() then
    MODEL.lua.simulateIsDemo = false
    MODEL.route.list.navigated.clear()
  else
    primary:ONMAPCLICK(sc_EasyMapClick)
  end
  local primary = MODEL.map.primary
  if primary.state() == "simulate_2d_nu" or primary.state() == "simulate_2d" or primary.state() == "simulate" then
    obs_enter_drag_mode:STOP()
    primary.exit_state()
    obs_enter_drag_mode:START("NO_TRIGGER")
  end
  if gSimulationEndPrevstate then
    PREVSTATE()
  end
  if gDetourAcceptanceMode_BeforeSimulation ~= -1 then
    MODEL.traffic.settings.detour_acceptance_mode = gDetourAcceptanceMode_BeforeSimulation
    gDetourAcceptanceMode_BeforeSimulation = -1
  end
  MODEL.screen.msgbox.switch_on()
end 

sc_SetFlyOverMode = function()
  if not MODEL.navigation.is_in_simulation() then
    return 
  end
  local mapLayer = MODEL.map.primary
  if mapLayer.state() ~= "simulate_2d_nu" and mapLayer.state() ~= "simulate_2d" and mapLayer.state() ~= "simulate" then
    if (MODEL.lua.vEasyMapMode() ~= EMapMode.Mode_2D_NU or not "simulate_2d_nu") and (MODEL.lua.vEasyMapMode() ~= EMapMode.Mode_2D or not "simulate_2d") then
    end
    mapLayer.enter_state("simulate")
    if MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D_NU then
      mapLayer.rotate = 0
    else
      mapLayer.rotate = 4096 - MODEL.navigation.car.heading()
    end
  end
  primary:ONMAPCLICK(sc_ShowHideSimulateControls)
  MODEL.navigation.autoreplan = false
  MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
  obs_flyover_stopped:START()
  sc_ShowHideSimulateControls()
end
 
-- blink

sc_gj_blink = function()

  if MODEL.navigation.has_route() then
	local DestATPETA = MODEL.navigation.eta_at_destination()
	local DestATPTmp = MODEL.lua.vgjATP_TmpTime()
	if DestATPTmp > DestATPETA then
		MODEL.lua.vgjATP_ShowArrTime = (DestATPTmp-DestATPETA)
	else
		MODEL.lua.vgjATP_ShowArrTime = (DestATPTmp-DestATPETA) * -1
	end
  end
  
  if not MODEL.lua.routeCalculation_todo() or not MODEL.lua.vgjRecalcInfo_Show() then 
    if MODEL.navigation.distance_to_destination() > 0 and gjRI_CalckEvent == 0 then
		MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
		MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination() 
	end	
  end
  
  if vActiveState() == "st_easynav" and wTemp_overview_distance ~= nil then
	sc_overview_check()
  end
  
  if vActiveState() == "st_easynav" and not MODEL.lua.dragMode() and MODEL.lua.wSplitScreenOpen() and MODEL.poi.initialized() then
	sc_wOnSplitScreenPOI_reset()
  end
  
end	  


-- recalc

createState("st_gj_recalc_settings")
st_gj_recalc_settings:useLayers(backgroundLayers, ui_gj_recalc_settings)
st_gj_recalc_settings.init = function()
  txtTitle:SET(m_i18n("Route Settings"))
end

sc_gj_recalc_OnRelease = function()
  sc_NextStateAnim(st_gj_recalc_settings, "horz_scroll", 1, "")
end
  
sc_gj_set_autorecalc = function()
  if MODEL.lua.vgjAutoRecalc() then
    MODEL.navigation.autoreplan = true
	MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
  else
    if MODEL.navigation.has_route() then
		MODEL.navigation.autoreplan = false
		MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
	else
		MODEL.navigation.autoreplan = true
		MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
	end
  end
end


sc_gj_recalculate = function()
  PLAYSOUND("!button")
  MODEL.navigation.autoreplan = true
  MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan() 
  MODEL.route.recalculate()
  killDelayed(gjDel4)
  gjDel4 = doDelayed(100, function()
	sc_gj_set_autorecalc()
  end
  )
end;


sc_gj_recalculate_start = function()
	gjRI_CalckEvent = 1
end

sc_gj_recalculate_end = function()

	if MODEL.lua.vgjRI_TmpDist() == 0 or MODEL.lua.vgjRI_TmpTime() == 0 then
		MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
		MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination()
		
--arriv time plan
		MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
		MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
	else

--arriv time plan
		if MODEL.lua.vgjATP_TmpRMethod() ~= MODEL.lua.routeMethodText() then
			MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
			MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
		end

		if (MODEL.lua.vgjRI_TmpDist() ~= MODEL.navigation.distance_to_destination() or MODEL.lua.vgjRI_TmpTime() ~= MODEL.navigation.time_to_destination()) and MODEL.lua.vgjRecalcInfo_Enable() then
			MODEL.lua.vgjRI_ShowTmpDist = MODEL.lua.vgjRI_TmpDist()-MODEL.navigation.distance_to_destination()
			MODEL.lua.vgjRI_ShowTmpTime = MODEL.lua.vgjRI_TmpTime()-MODEL.navigation.time_to_destination()

			
			doDelayed(30, function()
				if MODEL.navigation.distance_to_destination() > 0 then
					MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
					MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination()
					
					MODEL.lua.vgjRecalcInfo_Show = true
					killDelayed(gjDel3)
					gjDel3 = doDelayed(800, function()
						MODEL.lua.vgjRecalcInfo_Show = false
					end
					)

					if MODEL.lua.vgjRISoundName() ~= L"" then
						sc_gjplaysound(MODEL.lua.vgjRISoundName(), MODEL.lua.vgjRISoundVolume())
					end	 
				
				end
			end
			)

		end
		
	end

	killDelayed(gjDel2)
	gjDel2 = doDelayed(60, function()
		gjRI_CalckEvent = 0
	end
	)
	
--auto autoreplan
	sc_gjm_set_autorecalc()
	
end

sc_route_deleted_orig = sc_route_deleted
sc_route_deleted = function()
  sc_gj_route_end()
  sc_ResetRouteParams()
  MODEL.lua.JunctionViewHiddenByUser = false
  MODEL.route.list.navigated.off_road = MODEL.lua.ptp_navigation()
end


sc_gj_route_end = function()
--arriv time plan
	MODEL.lua.vgjRI_TmpDist = 0
	MODEL.lua.vgjRI_TmpTime = 0
	MODEL.lua.vgjATP_TmpTime = 0
	MODEL.lua.vgjRecalcInfo_Show = false
--auto autoreplan
	sc_gj_set_autorecalc()
end

sc_gj_reset_atp = function()
--arriv time plan
	MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
	MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
end
 
sc_gj_atpreset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset time?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_reset_atp", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end 


-- Home&Work
gFavoritesSearchStateisEntered = false
Monnomrac = L""
Monnomfav = L""

sc_gj_DefineHomeWork = function()
	MODEL.poi.flat_search.list.index = MODEL["*"]._index()
	Monnomfav = MODEL["*"].name()
	sc_gj_SBAttribRac()
end

sc_gj_DefineAddress = function(id)
	MODEL.lua.vgjAddr[id] = Monnomfav
	sc_back()
end

sc_map_local_menu_ContactsSHW = function()
	MODEL.lua.gjFAVNOCNT = false
	gSearchEngineIsInitialized = false
	sc_ForcePoiInit()
	sc_NextStateAnim(st_ManageFavoriteSHW, "horz_scroll", 1, "")
end

gFavoritesSearchStateisEnteredSHW = false
createState("st_ManageFavoriteSHW")
st_ManageFavoriteSHW:useLayers(backgroundLayers, "ui_ManageFavoriteSHW", "ui_List_Background")
st_ManageFavoriteSHW.init = function()
	if MODEL.lua.gjFAVNOCNT() then
		txtTitle:SET(m_i18n("Favourites"))
	else
		txtTitle:SET(m_i18n("Contacts"))
	end
	g_OnPoiListItemClicked = sc_FlatSearch_OnPoiItemClicked
	isFromFavorite = false
end

st_ManageFavoriteSHW.enter = function()
	gFavoritesSearchStateisEnteredSHW = true
	MODEL.lua.PoiListFilterString = L""
	MODEL.poi.flat_search.ext_name_filter.name = L""
	if MODEL.lua.gjFAVNOCNT() then
		sc_SearchFavorites()
	else
		sc_SearchContacts()
	end
end

st_ManageFavoriteSHW.exit = function()
	gFavoritesSearchStateisEnteredSHW = false
	isFromFavorite = false
	obs_poi_filter_search_done:STOP()
	obs_poi_filter_struct_search_done:STOP()
end

sc_map_local_menu_favoriteSHW = function()
	MODEL.lua.gjFAVNOCNT = true
	gSearchEngineIsInitialized = false
	sc_ForcePoiInit()
	sc_NextStateAnim(st_ManageFavoriteSHW, "horz_scroll", 1, "")
end

createState("st_SelectHomeWork")
st_SelectHomeWork:useLayers(backgroundLayers, "ui_SelectHomeWork", "ui_List_Background")
st_SelectHomeWork.init = function()
	txtTitle:SET(m_i18n("Select Home/Work"))
	ui_SBAttribRac:HIDE()
end

sc_gj_SelectHomeWork = function()
	sc_NextStateAnim(st_SelectHomeWork, "horz_scroll", 1, "")
end

createState("st_SBAttribRac")
st_SBAttribRac:useLayers(backgroundLayers, "ui_SBAttribRac")
st_SBAttribRac.init = function()
	txtTitle:SET(Monnomfav)
end

sc_gj_SBAttribRac = function()
sc_NextStateAnim(st_SBAttribRac, "horz_scroll", 1, "")
end

sc_gj_DelracFav = function()
	for i = 1,3 do
		if MODEL.lua.vgjAddr[i]() == Monnomrac then
			MODEL.lua.vgjAddr[i] = L""
		end
	end
end

sc_gj_RacDel_OnRelease = function(monnum)
	Monnomrac = MODEL.lua.vgjAddr[monnum]()
	if Monnomrac ~= L"" then
		local newMsgBox = MODEL.screen.msgbox.new
		newMsgBox.setup(2)
		newMsgBox.set_line(1, m_i18n("Are you sure you want to cancel shortcut?"))
		newMsgBox.set_line_wstr(2, Monnomrac)
		newMsgBox.setup_button(1, "sc_gj_DelracFav2", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
		newMsgBox.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
		MODEL.screen.msgbox.create_new()
	end
end

sc_gj_DelracFav2 = function()
	sc_gj_DelracFav()
	btnHW1:REDRAW()
	btnHW2:REDRAW()
	btnHW3:REDRAW()
end

sc_GoSearchHomeWork = function(oneortwo)
	sc_SearchHomeWork(oneortwo)
end

sc_SearchHomeWork = function(mavar)
	local sbTmphomework = var.new()
	sc_DeleteRoute()
	MODEL.poi.copy_query("poi.struct_search", "poi.flat_search", 1)
	local flat_search = MODEL.poi.flat_search
	flat_search.sort = MODEL.poi.struct_search.sort()
	flat_search.reset()
	flat_search.area = 3000000
	flat_search.center = "gps"
	flat_search.distance_on_route = "disabled"
	flat_search.calculate_detour = "disabled"
	flat_search.search_root = MODEL.poi.find_group("@Favourites")

	inpSI_Text:VALUE(MODEL.lua.vgjAddr[mavar]())

	flat_search.name_filter = ui.inpSI_Text.VALUE()
	flat_search.execute()
	if flat_search.list.size() > 0 then
		for item,index in ModelList_iter(MODEL.poi.flat_search.list) do
			if item.name() == ui.inpSI_Text.VALUE() then
				MODEL.my.poi.select_poi(item.provider_id(), item.id())
				MODEL.map.cursor.position = MODEL.my.map.selected_item.position()
				MODEL.poi.resultpoi.clear()
				MODEL.poi.resultpoi.add_poi_by_id(item.provider_id(), item.id())
				isFromFavorite = true
				PoiSelected = true
				sc_EasyRouteTo()
				sc_GO_onrelease()
				return 
			end
		end
	else
		flat_search.sort = MODEL.poi.struct_search.sort()
		flat_search.reset()
		flat_search.area = 3000000
		flat_search.center = "gps"
		flat_search.distance_on_route = "disabled"
		flat_search.calculate_detour = "disabled"
		flat_search.search_root = MODEL.poi.find_group("Contacts")
		flat_search.name_filter = ui.inpSI_Text.VALUE()
		flat_search.execute()
		if flat_search.list.size() > 0 then
			for item,index in ModelList_iter(MODEL.poi.flat_search.list) do
				if item.name() == ui.inpSI_Text.VALUE() then
					MODEL.my.poi.select_poi(item.provider_id(), item.id())
					MODEL.map.cursor.position = MODEL.my.map.selected_item.position()
					MODEL.poi.resultpoi.clear()
					MODEL.poi.resultpoi.add_poi_by_id(item.provider_id(), item.id())
					isFromFavorite = true
					PoiSelected = true
					sc_EasyRouteTo()
					sc_GO_onrelease()
					return 
				end
			end
		else
			sc_InfoMessageBox(m_i18n("Favourite not found."))
			return 
		end
	end
	sc_InfoMessageBox(m_i18n("Favourite not found."))
end

sc_gj_CreateTextAddress = function(id,text)
	if MODEL.lua.vgjAddr[id]() == L"" then
		return m_i18n( text .. " button : Not selected" )
	else
		local text = translated_format(m_i18n( text .. " button : %s" ), MODEL.lua.vgjAddr[id]())
		return text
	end
end


sc_gj_openhomework = function()
	MODEL.lua.vEasyNavTripInfoOpen = true
	killDelayed(gjDel7)
	gjDel7 = doDelayed(150, function()
		MODEL.lua.vEasyNavTripInfoOpen = false
	end
	)
end

--simulate

gjtSimControlsObjects = {"spr_SC_bg", "btn_simspeed", "txt_simspeed", "btn_ManNext", "spr_ManNext", "btn_sim_play", "spr_sim_play", "btn_sim_pause", "spr_sim_pause", "btn_ManPrev", "spr_ManPrev", "btn_simspeed1", "txt_simspeed1"}
sc_StartFadeSimControls_orig = sc_StartFadeSimControls
sc_StartFadeSimControls = function(from, to, time)
  for cntr = 1, #gjtSimControlsObjects do
    _G[gjtSimControlsObjects[cntr]]:BLENDALPHA(from, to, time)
  end
  scroll_SC.ALPHA = to
end
 
------------------------------------------------------
-- show play sound

sc_gj_plsshow = function()
	if MODEL.lua.vgj_PLSShowEnable() then	
		MODEL.lua.vgj_PLSShow = true
		killDelayed(gjDel5)
		gjDel5 = doDelayed(MODEL.lua.PLSAutoHideTime(), function()
			if MODEL.lua.PLSAutoHide() then
				MODEL.lua.vgj_PLSShow = false
			end	
		end
		)
	end		
end

sc_gj_plsswith = function()
	if MODEL.lua.vgj_PLSShow() then
		MODEL.lua.vgj_PLSShow = false
		killDelayed(gjDel6)
		gjDel6 = doDelayed(10, function()
			sc_NaviMenuAlphaDown()
		end
		)
	else
		sc_gj_plsshow()
	end
end

sc_gj_pls_timeswith = function()
	MODEL.lua.media_audioplayer_showelpased = not MODEL.lua.media_audioplayer_showelpased()
end 

-- overspeed ------------------
gjNearSpeed = 0 

sc_gj_Overspeed_on = function()
    if gjNearSpeed == 1 then
		return
	end

	if MODEL.lua.vgjOVSONSoundName() ~= L"" then
	    gjNearSpeed = 1
		sc_gjplaysound(MODEL.lua.vgjOVSONSoundName(), MODEL.lua.vgjOVSONSoundVolume())
	end
	
end


sc_gj_Overspeed_off = function()
    if gjNearSpeed == 0 then
		return
	end

	if MODEL.lua.vgjOVSOFFSoundName() ~= L"" then
	    gjNearSpeed = 0
		sc_gjplaysound(MODEL.lua.vgjOVSOFFSoundName(), MODEL.lua.vgjOVSOFFSoundVolume())
	end

end
  
-- sound play
tgjUserSoundType = ""
tgjSoundPlayed = -1
tgjSoundVolumeBackup = -1


createState("st_gj_sound_Settings")
st_gj_sound_Settings:useLayers(backgroundLayers, ui_gj_sound_Settings)
st_gj_sound_Settings.init = function()
  txtTitle:SET(m_i18n("Warning Settings"))
end

sc_gj_sound_OnRelease = function()
  sc_NextStateAnim(st_gj_sound_Settings, "horz_scroll", 1, "")
end


createState("st_gjUserSounds")
st_gjUserSounds:useLayers(backgroundLayers, ui_gjUserSounds)
st_gjUserSounds.init = function()
	txtTitle:SET(m_i18n("Select sound"))
end
 
sc_gjUserSoundsOnRelease = function()
	local name = MODEL["*"].name()
	local volume = 0
	if tgjUserSoundType == "laneinfo" then
		MODEL.lua.vgjLaneSoundName = name
		volume = MODEL.lua.vgjLaneSoundVolume()
	elseif tgjUserSoundType == "start" then
		MODEL.lua.vgjStartSoundName = name
		volume = MODEL.lua.vgjStartVolume()
	elseif tgjUserSoundType == "autoarrive" then
		MODEL.lua.vgjAAD_SoundName = name
		volume = MODEL.lua.vgjAAD_SoundVolume()
	elseif tgjUserSoundType == "recalculate" then
		MODEL.lua.vgjRISoundName = name
		volume = MODEL.lua.vgjRISoundVolume()
	elseif tgjUserSoundType == "ovrspeedon" then
		MODEL.lua.vgjOVSONSoundName = name
		volume = MODEL.lua.vgjOVSONSoundVolume()
	elseif tgjUserSoundType == "ovrspeedoff" then
		MODEL.lua.vgjOVSOFFSoundName = name
		volume = MODEL.lua.vgjOVSOFFSoundVolume()
	elseif tgjUserSoundType == "speedchon" then
		MODEL.lua.vgjSPCHONSoundName = name
		volume = MODEL.lua.vgjSPCHSoundVolume()
	elseif tgjUserSoundType == "speedchoff" then
		MODEL.lua.vgjSPCHOFFSoundName = name
		volume = MODEL.lua.vgjSPCHSoundVolume()
	end
	sc_back()
	sc_gjplaysound(name, volume)
end
 
sc_gjUserSoundsPlay_OnRelease = function()
	sc_gjplaysound(MODEL["*"].name(), 65)
end
 
sc_gjUserSoundsDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this User sound from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserSoundsDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gjUserSoundsDel_OnRelease_OK = function()
	MODEL.ui.gjUserSoundList.remove(MODEL.ui.gjUserSoundList.list.index())
	MODEL.ui.gjUserSoundList.save()
end
 
sc_gjUserSoundsAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all User sounds from list?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserSoundsAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gjUserSoundsAll_OnRelease_OK = function()
	MODEL.ui.gjUserSoundList.clear()
	MODEL.ui.gjUserSoundList.save()
end
 
sc_RescanwUserSounds_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The previous list will be removed. Are you sure you want to rescan user sounds?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_RescanwUserSounds_OnReleaseOK", m_i18n("Rescan sounds"), L"", "ico_Done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_RescanwUserSounds_OnReleaseOK = function()
	ui_gjSoundScanning:SHOW()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L"%app%/ui_igo9/audio"
	oasisFiles.filter = L"fcategory:5"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_UserSoundScan_Finished:START("NO_TRIGGER")
end
 
  
sc_RescanwUserSounds_done = function()
	obs_Files_UserSoundScan_Finished:STOP()
	ui_gjSoundScanning:HIDE()
	MODEL.ui.gjUserSoundList.clear()
	ui.gjUserSoundList:add({name=L" "})
	local filename, fpath = L"", L""
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		filename = MODEL.oasis.files.list[i].fname():lower()
		fpath = MODEL.oasis.files.list[i].fpath():lower()
		fpath = wstring.sub(fpath, 15, #fpath)
		if fpath == filename then
			ui.gjUserSoundList:add({name=wstring.gsub(filename, L".wav", L"")})
		end
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	MODEL.ui.gjUserSoundList.save()
end
 
 
 
sc_RescanwUserSounds_stop = function()
	obs_Files_UserSoundScan_Finished:STOP()
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	ui_gjSoundScanning:HIDE()
end
 
sc_gjplaysound = function(sound, volume)
	if sound == L" " then
		return
	end
	if tgjSoundPlayed ~= -1 then
		killDelayed(tgjSoundPlayed)
		tgjSoundPlayed = -1
	end
	if tgjSoundVolumeBackup == -1 then
		tgjSoundVolumeBackup = MODEL.sound.alert_volume()
	end
	if MODEL.sound.alert_volume() ~= volume then
		MODEL.sound.alert_volume = volume
	end
	MODEL.sound.playchanneltest("alarmeffect", sound)
	tgjSoundPlayed = doDelayed(100, function()
		if tgjSoundVolumeBackup ~= -1 then
			MODEL.sound.alert_volume = tgjSoundVolumeBackup
			tgjSoundVolumeBackup = -1
		end
	end
	)
end   
  
  
--gj splitscreen
wSplitScreenPOIReady = true
gGlobalSearchAroundArea = 50000
wFind_createroute = false 
   
sc_wOnSplitScreenPOI = function()
	if MODEL.poi.initialized() then
		sc_wSplitPoiInitialized()
	else
		obs_splitpoiinitialized:START("NO_TRIGGER")
		MODEL.other.force_init_finish("poi")
	end
end
 
sc_wSplitPoiInitialized = function()
	obs_splitpoiinitialized:STOP()
	local changed_groups = false
	if MODEL.ui.lm_splitpoi_groups.size() > 8 then
		MODEL.ui.lm_splitpoi_groups.resize(8)
		changed_groups = true
	end
	for i = 0, MODEL.ui.lm_splitpoi_groups.size() - 1 do
		if sc_wSplitScreenPOIGroupGetName(MODEL.ui.lm_splitpoi_groups[i].name()) == nil then
			MODEL.ui.lm_splitpoi_groups.remove(i)
			changed_groups = true
		end
	end
	if changed_groups then
		MODEL.ui.lm_splitpoi_groups.save()
	end
	sc_wOnSplitScreenPOI_reset_done()
end
   
   
sc_wOnSplitScreenPOI_reset = function()
-----	if MODEL.navigation.car.current_speed() and not MODEL.navigation.is_in_simulation() and wSplitScreenPOIReady then
	if not MODEL.navigation.is_in_simulation() and wSplitScreenPOIReady then
		sc_wOnSplitScreenPOI_reset_done()
	end
end
 
sc_wOnSplitScreenPOI_reset_done = function()
	wSplitScreenPOIReady = false
	local flat_search = MODEL.poi.flat_search

	flat_search.reset()
	
	flat_search.max_result = 20
		
	flat_search.center = MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() and "route" or "gps"
	flat_search.distance_on_route = MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() and "enabled" or "disabled"
	flat_search.calculate_detour = MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() and "forced" or "disabled"

	flat_search.show_groups.remove_all()
	for i = 0, MODEL.ui.lm_splitpoi_groups.size() - 1 do
		flat_search.show_groups.add(MODEL.poi.find_group(MODEL.ui.lm_splitpoi_groups[i].name()))
	end

	flat_search.add_to_filter_chain("poi_pre", "show_groups")
	if MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() then
		flat_search.area = MODEL.lua.wSplitScreenPOIDistance_20()
	else
		flat_search.area = gGlobalSearchAroundArea
	end
		
	flat_search.name_filter = MODEL.lua.wSplitScreenPOIFilter()

	flat_search.sort = MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() and "detour_group" or "distance"
	flat_search.execute()
	
	obs_wSplitScreenPOI_search_done:STOP()
	if flat_search.ready() then
		sc_wOnSplitScreenPOI_reset_doneOK()
	else
		obs_wSplitScreenPOI_search_done:START("NO_TRIGGER")
	end
	
end
 
sc_wOnSplitScreenPOI_reset_doneOK = function()
    obs_wSplitScreenPOI_search_done:STOP()
	local current, currentpoi = nil, nil
	local count, detour, dist, detour_length = 0, 0, 0, 0
	local flat_search = MODEL.poi.flat_search
			
	for i = 0, flat_search.list.size() - 1 do
		currentpoi = flat_search.list[i]
		if sc_wOnSplitScreenPOI_checkangle(currentpoi.position()) then
			dist = currentpoi.distance()
			if MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() then
				detour = currentpoi.detour_icon()
				dist = currentpoi.distance_on_route()
				detour_length = currentpoi.detour_length()
			end
			if MODEL.ui.lm_splitpoi.size() < (count + 1) then
				ui.lm_splitpoi:add({name = currentpoi.name(), icon_id = currentpoi.icon(), detour_id = detour, position = currentpoi.position(), distance = dist, detour_len = detour_length, provider_id = currentpoi.provider_id(), id = currentpoi.id()})
			else
				current = MODEL.ui.lm_splitpoi[count]
				current.name = currentpoi.name()
				current.icon_id = currentpoi.icon()
				current.detour_id = detour
				current.position = currentpoi.position()
				current.distance = dist
				current.detour_len = detour_length
				current.provider_id = currentpoi.provider_id()
				current.id = currentpoi.id()
			end
			count = count + 1
		end
		
		if MODEL.lua.JunctionViewVisible() then
			if count > 0 then
				break
			end
		end
				
		if MODEL.lua.wSplitTopChg() or MODEL.lua.SignpostIsValid() then
			if count > 1 then
				break
			end
		else
			if count > 2 then
				break
			end
		end
	end
	
	MODEL.ui.lm_splitpoi.resize(count)
	wSplitScreenPOIReady = true
end
 
sc_wOnSplitScreenPOI_checkangle = function(pos)
	if MODEL.lua.wSplitScreenPOIOnRoute() and MODEL.route.list.navigated.has_navigable_path() then
		return true
	end
	local angle = 0
	ui.ui_SimulationStop.position_splitpoi = pos
	angle = ui.ui_SimulationStop.direction_splitpoi()
	if angle < 0 then
		angle = 4096 + angle
	end
	angle = angle - 2048
	if angle < 0 then
		angle = - angle
	end
	return angle <= (2048 * MODEL.lua.wSplitScreenPOIAngle()/180)
end

sc_wSet_CreateRoute = function(action)
	if MODEL.navigation.has_route() then
		wFind_createroute = action
	else
		wFind_createroute = not action
	end
end

sc_FlatSearch_OnPoiItemClicked = function(thisPOI)
	local currentPoi = thisPOI ~= nil and thisPOI or MODEL["*"]
	MODEL.my.poi.select_poi(currentPoi.provider_id(), currentPoi.id())
	MODEL.map.cursor.position = MODEL.my.map.selected_item.position()
	MODEL.poi.resultpoi.clear()
	MODEL.poi.resultpoi.add_poi_by_id(currentPoi.provider_id(), currentPoi.id())
	PoiSelected = true
	MODEL.map.primary.clear_clicked_lists()
	if MODEL.lua.VRStatus() ~= eVRStatus.inactive or wFind_createroute then
		sc_FindOnMap_Select_onrelease()
	else
		sc_NextStateAnim(st_FindOnMap, "horz_scroll", 1, "")
	end
end

-------------

sc_wSplitScreenPOIFilterStartSelect = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text.VALUE = L""
	inpSI_Text.EMPTYTITLE = m_i18n("<Enter the Name of the Place>")
	MODEL.lua.easyShowDoneKey = true
	ui.vKeyTableDone = sc_wSplitScreenPOIFilterSelectDone
	inputFieldRequired = false
	txtTitle.TEXT = m_i18n("Enter Filter")
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_wSplitScreenPOIFilterSelectDone = function()
	MODEL.lua.wSplitScreenPOIFilter = ui.inpSI_Text.VALUE()
	PREVSTATE()
end


sc_wSplitScreenPOISettingsGroupList_OnRelease = function()
	sc_NextStateAnim(st_wSplitScreenPOISettingsGroupList, "horz_scroll", 1, "")
end
  
createState("st_wSplitScreenPOISettingsGroupList")
st_wSplitScreenPOISettingsGroupList:useLayers(backgroundLayers, ui_List_Background, ui_wSplitScreenPOISettingsGroupList, localMenuLayers)
st_wSplitScreenPOISettingsGroupList.init = function()
	txtTitle.TEXT = m_i18n("POI category list")
	sc_init_local_menu("ui.lm_moremenu_splitpoi_groups")
end
 
createState("st_wSplitScreenPOISettings")
st_wSplitScreenPOISettings:useLayers(backgroundLayers, ui_wSplitScreenPOISettings)
st_wSplitScreenPOISettings.init = function()
	txtTitle.TEXT = m_i18n("POI list on the map Settings")
end
 
st_wSplitScreenPOISettings.exit = function()
	SAVESETTINGS()
end

sc_wSplitScreenPOIGroupSave_OnRelease = function()
	sc_close_local_menu()
	txtTitle.TEXT = m_i18n("Save POI category list")
	inpSI_Text.EMPTYTITLE = m_i18n("<Enter a name for the list>")
	inpSI_Text.value = L""
	ui.vKeyTableDone = sc_wSplitScreenPOIGroupSave_OnReleaseDone
	MODEL.lua.easyShowDoneKey = true
	inputFieldRequired = true
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_wSplitScreenPOIGroupSave_OnReleaseDone = function()
	local str = ""
	local text = ui.inpSI_Text.value
	for i = 0, MODEL.ui.lm_splitpoi_groups.size() - 1 do
		str = str .. MODEL.ui.lm_splitpoi_groups[i].name() .. "|||"
	end
	ui.lm_splitpoi_savedgroups:add({name = text, groups = str})
	MODEL.ui.lm_splitpoi_savedgroups.save()
	sc_back()
end
 
sc_wSplitScreenPOIGroupLoad_OnRelease = function()
	sc_close_local_menu()
	sc_NextStateAnim(st_wSplitScreenPOISettingsGroupListSaved, "horz_scroll", 1, "")
end
 
createState("st_wSplitScreenPOISettingsGroupListSaved")
st_wSplitScreenPOISettingsGroupListSaved:useLayers(backgroundLayers, ui_List_Background, ui_wSplitScreenPOISettingsGroupListSaved)
st_wSplitScreenPOISettingsGroupListSaved.init = function()
	txtTitle.TEXT = m_i18n("Saved POI category lists")
end
 
sc_wSplitScreenPOIGroupSavedDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this element from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_wSplitScreenPOIGroupSavedDel_OnRelease_OK", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wSplitScreenPOIGroupSavedDel_OnRelease_OK = function()
	MODEL.ui.lm_splitpoi_savedgroups.remove(MODEL.ui.lm_splitpoi_savedgroups.list.index())
	MODEL.ui.lm_splitpoi_savedgroups.save()
	if MODEL.ui.lm_splitpoi_savedgroups.list.isempty() then
		PREVSTATE()
	end
end
 
sc_wSplitScreenPOIGroupSavedDelAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all saved POI category lists?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wSplitScreenPOIGroupSavedDelAll_OnRelease_OK", m_i18n("Delete All"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wSplitScreenPOIGroupSavedDelAll_OnRelease_OK = function()
	MODEL.ui.lm_splitpoi_savedgroups.clear()
	MODEL.ui.lm_splitpoi_savedgroups.save()
	PREVSTATE()
end
 
sc_wSplitScreenPOIGroupSavedLoad_OnRelease = function()
	MODEL.ui.lm_splitpoi_groups.clear()
	for value in string.gmatch(MODEL["*"].groups(), "(.-)|||") do 
		ui.lm_splitpoi_groups:add({name = value})
	end
	if MODEL.ui.lm_splitpoi_groups.size() > 8 then
		MODEL.ui.lm_splitpoi_groups.resize(8)
	end
	for i = 0, MODEL.ui.lm_splitpoi_groups.size() - 1 do
		if sc_wSplitScreenPOIGroupGetName(MODEL.ui.lm_splitpoi_groups[i].name()) == nil then
			MODEL.ui.lm_splitpoi_groups.remove(i)
		end
	end
	MODEL.ui.lm_splitpoi_groups.save()
	PREVSTATE()
end
  
sc_SelectSplitScreenDistanceDone = function()
	if not inpValueInteger_isempty() then
		MODEL.lua.wSplitScreenPOIDistance_20 = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
 
sc_wSplitScreenPOIGroupPreStartSelect = function()
	sc_wPOIStructureMainReset(true)
end

sc_wSettingSplitScreenMode = function()
	sc_NextStateAnim(st_wSplitScreenPOISettings, "horz_scroll", 1, "")
end

sc_wSplitScreenPOIGroupStartSelect = function()
	sc_wSplitScreenPOIGroupPreStartSelect()
	sc_NextStateAnim(st_wSplitScreenPOIGroupSettings, "fade", 1, "")
end

sc_Structure_ToChildAP = function()
	table.insert(EPoiScrollPos, MODEL.ui.lst_AP.scroll_pos())
	local structure = MODEL.poi.structure
	structure.group_list.index = index
	structure.to_child()
	structure.execute()
	MODEL.ui.lst_AP.scroll_pos = 0
	sc_wSetTitle_AP()
end

sc_Structure_ToParentAP = function()
	local structure = MODEL.poi.structure
	local LastScrollPos = EPoiScrollPos[table.maxn(EPoiScrollPos)]
	table.remove(EPoiScrollPos)
	structure.to_parent()
	structure.execute()
	sc_wSetTitle_AP()
	doDelayed(1, function() MODEL.ui.lst_AP.scroll_pos = LastScrollPos end)
end

sc_wUserPOISearchParamsPOIGroupSelectStart = function()
	MODEL.lua.wUserPOIParamsPOIGroup = MODEL["*"].path()
end 
 
sc_wSetTitle_AP = function()
	local title = translate(m_i18n("Add POI")) .. (MODEL.poi.structure.parent_name() and L" - " or L"") .. MODEL.poi.structure.parent_name()
	local titlealt = translate(m_i18n("Select group")) .. (MODEL.poi.structure.parent_name() and L" - " or L"") .. MODEL.poi.structure.path_text()
	txtTitle.TEXT = vActiveState() == "st_addpoi" and title or titlealt
end

createState("st_AddPOI")
st_AddPOI:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_AddPOI.enter = function()
	EPoiScrollPos = {}
end

st_AddPOI.init = function()
	sc_wSetTitle_AP()
end


createState("st_wUserPOISearchParamsPOIGroupSettings")
st_wUserPOISearchParamsPOIGroupSettings:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_wUserPOISearchParamsPOIGroupSettings.enter = function()
	EPoiScrollPos = {}
end

st_wUserPOISearchParamsPOIGroupSettings.init = function()
	sc_wSetTitle_AP()
end

createState("st_wSplitScreenPOIGroupSettings")
st_wSplitScreenPOIGroupSettings:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_wSplitScreenPOIGroupSettings.enter = function()
	EPoiScrollPos = {}
end

st_wSplitScreenPOIGroupSettings.init = function()
	sc_wSetTitle_AP()
end


sc_wSplitScreenPOIGroupSelectStart = function()
	MODEL.lua.wSplitScreenPOIGroup = MODEL["*"].path()
end
 
sc_wSplitScreenPOIGroupSelectDone = function()
	local model = MODEL.ui.lm_splitpoi_groups.unfiltered_list
	local value = false
	for item,index in ModelList_iter(model) do
		if item.name() == MODEL.lua.wSplitScreenPOIGroup() then
			value = true
			break
		end
	end
	if not value then
		ui.lm_splitpoi_groups:add({name=MODEL.lua.wSplitScreenPOIGroup()})
		MODEL.ui.lm_splitpoi_groups.save()
	end
	sc_back()
end
 
sc_wPOIStructureMainReset = function(pictures)
	sc_ForcePoiInit()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	if pictures then
		MODEL.poi.structure.add_provider(MODEL.poi.find_provider("picturepoi"))
	end
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
end

sc_wChangePOIGroup = function()
	sc_close_local_menu()
	sc_wPOIStructureMainReset(false)
	sc_NextStateAnim(st_wChangePOIGroup, "fade", 1, "")
end

sc_wChangePOIGroupDone = function()
	MODEL.my.poi.current.set_group(MODEL.poi.structure.search_root())
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	PREVSTATE()
end

createState("st_wChangePOIGroup")
st_wChangePOIGroup:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_wChangePOIGroup.enter = function()
	EPoiScrollPos = {}
end

st_wChangePOIGroup.init = function()
	sc_wSetTitle_AP()
end

sc_wUserPOISearchParamsPOIGroupSelectDone = function()
	MODEL.ui.lm_wuser_poi_search_params[MODEL.lua.wSettingDistIcon()].group = MODEL.lua.wUserPOIParamsPOIGroup()
	sc_back()
end
 
sc_wUserPOIParamsPOIGroupChildIsSelected = function(selectedGroup, currentID)
	return MODEL.poi.is_group_descendant_of(MODEL.poi.find_group(selectedGroup), currentID)
end

sc_wSplitScreenPOIGroupDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this element from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_wSplitScreenPOIGroupDel_OnRelease_OK", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wSplitScreenPOIGroupDel_OnRelease_OK = function()
	MODEL.ui.lm_splitpoi_groups.remove(MODEL.ui.lm_splitpoi_groups.list.index())
	MODEL.ui.lm_splitpoi_groups.save()
end

sc_wSplitScreenPOIGroupGetName = function(cat)
	local groupID = MODEL.poi.find_group(cat)
	if groupID == -1 then
		return nil
	end
	MODEL.my.poi.select_group(groupID)
	return MODEL.my.poi.current_group.name()
end
 
sc_wSplitScreenPOIGroupGetPath = function(cat)
	local groupID = MODEL.poi.find_group(cat)
	if groupID == -1 then
		return nil
	end
	local path, char = L"", L""
	while groupID > 0 do
		MODEL.my.poi.select_group(groupID)
		path = MODEL.my.poi.current_group.name() .. char .. path
		char = L"  "
		groupID = MODEL.my.poi.current_group.parent_id()
	end
	return path
end

sc_wRealTimeCollectChanged = function()
	if type(sc_RealTimeCollectChanged) == "function" then
		sc_RealTimeCollectChanged()
	end
end
